package com.cesgroup.bdc.SelfDefinedGroup.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.util.List;

/**
 * <p>
 * 自定义组
 * </p>
 *
 * @author ChenKai
 * @since 2019-07-08
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("SELF_DEFINED_GROUP")
public class SelfDefinedGroup implements Serializable {
	private static final long serialVersionUID = -3594073836451067384L;

	/**
	 * 主键ID
	 */
	@TableId("ID")
	private String id;

	/**
	 * 组名
	 */
	@TableField("GROUP_NAME")
	private String groupName;

	/**
	 * 描述
	 */
	@TableField("DESCRIBTION")
	private String describtion;


	/**
	 * 创建人ID
	 */
	@TableField("CREATE_USER_ID")
	private String createUserId;

	/**
	 * 创建人姓名
	 */
	@TableField("CREATE_USER_NAME")
	private String createUserName;

	/**
	 * 部门列表
	 */
	@TableField(exist = false)
	private List<SelfDefinedGroupUser> deptList;


    /**
     * 创建部门id
     */
    @TableField("DEPT_ID")
    private String deptId;

    /**
     * 创建部门名称
     */
    @TableField("DEPT_NAME")
    private String deptName;
}
