package com.cesgroup.bdc;

import com.cesgroup.kingkong.autoconfigure.cis.CipherConfiguration;
import com.cesgroup.kingkong.core.ApplicationContextUtils;
import com.cesgroup.kingkong.shiro.config.ShiroFilterChainDefinitionBuilder;
import com.cesgroup.kingkong.shiro.config.ShiroWebConfigurer;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.builder.SpringApplicationBuilder;
import org.springframework.boot.web.servlet.support.SpringBootServletInitializer;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Import;
import org.springframework.web.bind.annotation.CrossOrigin;

@SpringBootApplication
@Import(value = {CipherConfiguration.class})
public class WebApplication extends SpringBootServletInitializer implements ShiroWebConfigurer {
	public static void main(String[] args) {
		SpringApplication.run(WebApplication.class, args);
	}

	@Bean
	public ApplicationContextUtils spplicationContextUtils() {
		return new ApplicationContextUtils();
	}

	@Override
	protected SpringApplicationBuilder configure(SpringApplicationBuilder application) {
		return application.sources(WebApplication.class);
	}

	@Override
	public void configureFilterChainDefinition(final ShiroFilterChainDefinitionBuilder builder) {
		builder.anon("/login.html");
		builder.anon("/loginCA**");
		builder.anon("/loginCA/**");
		builder.anon("/loginAjax");
		builder.anon("/login/temp-pwd");
		builder.anon("/attachment/viewOfd/**");
		builder.anon("/static/**");
		builder.anon("/mail-receive/getAllToBeDoneCounts4other");
		//收发文单点登录专用

		builder.anon("/loginSL**");
		builder.anon("/loginSL/**");
		builder.anon("/cesEncrypt/**");
		builder.anon("/cesEncrypt2/**");
		builder.anon("/docReceive/**");
		builder.anon("/attachment/uploadOnlyOneDZYZ/**");
	}
}