package com.cesgroup.bdc.apply.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * @ClassName:ExpireVo
 * @Auther: ChenKai
 * @Date: 2019-07-25 10:37
 * @Description: 过期数据查询条件
 * @Version:1.0
 */
@Data
public class ExpireVo {

    private static final long serialVersionUID = -7278940954269058324L;

    /**
     * 申请人
     */
    private String applyUserName;
    /**
     * 申请单位
     */
    private String applyDeptName;
    /**
     * 原有效时间-开始
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date effDateS;
    /**
     * 原有效时间-结束
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date effDateE;
    /**
     * 审批时间-开始
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date approveDateS;
    /**
     * 审批时间-结束
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date approveDateE;

    /**
     * 延期时间-开始
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date expireDateS;
    /**
     * 延期时间-结束
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date expireDateE;
    /**
     * 标题
     */
    private String mailTitle;
    /**
     * 审批人姓名
     */
    private String approveUserName;
}