package com.cesgroup.bdc.attachment.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 附件
 * </p>
 *
 * @author shen.shaohua
 * @since 2019-07-02
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("ATTACHMENT")
public class Attachment implements Serializable {
	private static final long serialVersionUID = 8662193349489363702L;

	@TableId("ID")
	private String id;

	/**
	 * 文件表id
	 */
	@TableField("DISK_FILE_ID")
	private String diskFileId;

	/**
	 * 创建人id
	 */
	@TableField("CREATOR_ID")
	private String creatorId;

	/**
	 * 创建人名称
	 */
	@TableField("CREATOR_NAME")
	private String creatorName;

	/**
	 * 创建人部门id
	 */
	@TableField("CREATE_DEPT_ID")
	private String createDeptId;

	/**
	 * 创建人部门名称
	 */
	@TableField("CREATE_DEPT_NAME")
	private String createDeptName;

	/**
	 * 创建时间
	 */
	@TableField("CREATE_TIME")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date createTime;

	/**
	 * 所属模块
	 */
	@TableField("MODULE")
	private String module;

	/**
	 * 关联id
	 */
	@TableField("RELEVANCE_ID")
	private String relevanceId;

	/**
	 * 文件标密
	 */
	@TableField("SECURITY_LEVEL_FILE")
	private String securityLevelFile;
}
