package com.cesgroup.bdc.attachment.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 附件文件
 * </p>
 *
 * @author shen.shaohua
 * @since 2019-07-11
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("DISK_FILE")
public class DiskFile implements Serializable {
	private static final long serialVersionUID = -1028692842356839457L;

	@TableId("ID")
	private String id;
	/**
	 * 创建人id
	 */
	@TableField("CREATOR_ID")
	private String creatorId;

	/**
	 * 创建人名称
	 */
	@TableField("CREATOR_NAME")
	private String creatorName;
	/**
	 * 创建时间
	 */
	@TableField("CREATE_TIME")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date createTime;

	/**
	 * 原文件名
	 */
	@TableField("ORIGINAL_NAME")
	private String originalName;
	/**
	 * 现文件名
	 */
	@TableField("FILE_NAME")
	private String fileName;

	/**
	 * 文件类型
	 */
	@TableField("CONTENT_TYPE")
	private String contentType;
	/**
	 * 文件扩展名
	 */
	@TableField("EXT")
	private String ext;
	/**
	 * 文件大小(byte)
	 */
	@TableField("FILE_SIZE")
	private Long fileSize;
	/**
	 * 相对路径
	 */
	@TableField("PATH")
	private String path;
	/**
	 * 附件文本内容
	 */
	@TableField("TEXT")
	private String text;
}
