package com.cesgroup.bdc.attachment.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.cesgroup.bdc.attachment.entity.PrintNum;
import com.cesgroup.bdc.attachment.mapper.PrintNumMapper;
import com.cesgroup.bdc.attachment.service.IPrintNumService;
import com.cesgroup.bdc.util.CuiPage;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 附件打印次数表 服务实现类
 * </p>
 *
 * @author ChenKai
 * @since 2019-07-17
 */
@Service
public class PrintNumServiceImpl extends ServiceImpl<PrintNumMapper, PrintNum> implements IPrintNumService {

    @Override
    public PrintNum selectByAttachIdAndReceiveId(String id, String businessId) {
        QueryWrapper<PrintNum> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("ATTACH_ID", id).eq("MIAL_RECEIVE_ID", businessId);
        return getBaseMapper().selectOne(queryWrapper);
    }

    @Override
    public int updatePrintNum(String attachmentId, String businessId, String printTime) {
        QueryWrapper<PrintNum> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("ATTACH_ID", attachmentId).eq("MIAL_RECEIVE_ID", businessId);
        PrintNum printNum = getBaseMapper().selectOne(queryWrapper);
        int prT = Integer.parseInt(printNum.getPrintNumb());
        int printT = Integer.parseInt(printTime);
        if (prT > 0) {
            prT = prT - printT;
        }
        printNum.setPrintNumb("" + prT);
        UpdateWrapper<PrintNum> updateWrapper = new UpdateWrapper<>();
        updateWrapper.eq("ATTACH_ID", attachmentId).eq("MIAL_RECEIVE_ID", businessId);

        return getBaseMapper().update(printNum, updateWrapper);
    }

}
