package com.cesgroup.bdc.logs.controller;

import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.cesgroup.bdc.logs.entity.LoginLog;
import com.cesgroup.bdc.logs.service.ILoginLogService;
import com.cesgroup.bdc.util.CuiPage;
import com.cesgroup.bdc.util.PageVo;
import com.cesgroup.kingkong.web.BaseServiceController;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;

/**
 * <p>
 * 登录日志 前端控制器
 * </p>
 *
 * @author shen.shaohua
 * @since 2019-07-24
 */
@Controller
@RequestMapping("/login-log")
public class LoginLogController extends BaseServiceController<LoginLog, ILoginLogService> {
	/**
	 * 登录日志列表页面
	 */
	@RequestMapping("/index")
	public ModelAndView index() {
		ModelAndView mv = new ModelAndView("loginLog/index");
		return mv;
	}

	/**
	 * 日志列表分页查询
	 */
	@RequestMapping("/indexQuery")
	@ResponseBody
	public PageVo indexQuery(CuiPage<LoginLog> pager, HttpServletRequest request) {
		QueryWrapper<LoginLog> queryWrapper = new QueryWrapper<>();

		String userName = request.getParameter("userName");
		if (StrUtil.isNotBlank(userName)) {
			queryWrapper.like("USER_NAME", userName);
		}
		String deptName = request.getParameter("deptName");
		if (StrUtil.isNotBlank(deptName)) {
			queryWrapper.like("DEPT_NAME", deptName);
		}
		String loginStatus = request.getParameter("loginStatus");
		if (StrUtil.isNotBlank(loginStatus)) {
			queryWrapper.eq("LOGIN_STATUS", loginStatus);
		}
		String loginTimeBegin = request.getParameter("loginTimeBegin");
		if (StrUtil.isNotBlank(loginTimeBegin)) {
			Date begin = DateUtil.parseDate(loginTimeBegin);
			queryWrapper.ge("LOGIN_TIME", begin);
		}
		String loginTimeEnd = request.getParameter("loginTimeEnd");
		if (StrUtil.isNotBlank(loginTimeEnd)) {
			Date end = DateUtil.parseDateTime(loginTimeEnd + " 23:59:59");
			queryWrapper.le("LOGIN_TIME", end);
		}

		IPage<LoginLog> p = getBaseService().page(pager, queryWrapper);
		PageVo<LoginLog> pv = PageVo.convertFromMybatisplusPage(p);
		return pv;
	}

}
