package com.cesgroup.bdc.logs.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.cesgroup.bdc.logs.entity.Logs;
import com.cesgroup.bdc.logs.service.ILogsService;
import com.cesgroup.bdc.util.CuiPage;
import com.cesgroup.bdc.util.PageVo;
import com.cesgroup.kingkong.web.BaseServiceController;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.time.DateFormatUtils;
import org.springframework.http.HttpRequest;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author shen.shaohua
 * @since 2019-07-02
 */
@Controller
@RequestMapping("/logs")
public class LogsController extends BaseServiceController<Logs, ILogsService> {

	@RequestMapping("/index")
	public ModelAndView index(HttpServletRequest request) {
		ModelAndView mv = new ModelAndView("logs/index");
		return mv;
	}

	@RequestMapping("/query")
	@ResponseBody
	public PageVo query(CuiPage<Logs> pager, Logs entity) {
		QueryWrapper<Logs> wrapper = Wrappers.query(entity);
		IPage<Logs> p = getBaseService().page(pager, wrapper);
		PageVo<Logs> pv = PageVo.convertFromMybatisplusPage(p);
		return pv;
	}


	@RequestMapping("/queryByKeyWords")
	@ResponseBody
	public PageVo queryByKeyWords(CuiPage<Logs> pager, Logs entity, HttpServletRequest request) {
		String startTime=request.getParameter("startTime");
		String endTime=request.getParameter("endTime");
		QueryWrapper<Logs> wrapper = Wrappers.query();
		if(StringUtils.isNotBlank(entity.getUserName())){
			wrapper.like("USER_NAME",entity.getUserName());
		}

		if(StringUtils.isNotBlank(entity.getOrgName())){
			wrapper.like("ORG_NAME",entity.getOrgName());
		}

		if(StringUtils.isNotBlank(entity.getLogType())){
			wrapper.like("LOG_TYPE",entity.getLogType());
		}

		if (StringUtils.isNotBlank(startTime)){
			wrapper.ge("CREATE_TIME",startTime);
		}

		if (StringUtils.isNotBlank(endTime)){
			wrapper.le("CREATE_TIME",endTime);
		}
		wrapper.orderByDesc("CREATE_TIME");
		IPage<Logs> p = getBaseService().page(pager, wrapper);
		PageVo<Logs> pv = PageVo.convertFromMybatisplusPage(p);
		return pv;
	}


}
