package com.cesgroup.bdc.logs.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.time.LocalDateTime;
import java.util.Date;

/**
 * <p>
 * <p>
 * </p>
 *
 * @author ChenKai
 * @since 2019-07-19
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("LOGS")
public class Logs implements Serializable {

	private static final long serialVersionUID = 1L;

	/**
	 * 主键ID
	 */
	@TableId("ID")
	private String id;

	/**
	 * 操作类型
	 */
	@TableField("LOG_TYPE")
	private String logType;

	/**
	 * 操作人ID
	 */
	@TableField("USER_ID")
	private String userId;

	/**
	 * 操作人名字
	 */
	@TableField("USER_NAME")
	private String userName;

	/**
	 * 操作详情
	 */
	@TableField("OPERATE")
	private String operate;

	/**
	 * 操作状态
	 */
	@TableField("STATUS")
	private String status;

	/**
	 * 创建时间
	 */
	@TableField("CREATE_TIME")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date createTime;

	/**
	 * 路径
	 */
	@TableField("URL")
	private String url;

	/**
	 * 操作客户端ip
	 */
	@TableField("IP")
	private String ip;

	/**
	 * 操作部门ID
	 */
	@TableField("ORG_ID")
	private String orgId;

	/**
	 * 错误信息
	 */
	@TableField("ERROR_MSG")
	private String errorMsg;

	/**
	 * 操作部门名字
	 */
	@TableField("ORG_NAME")
	private String orgName;

	/**
	 * 操作模块
	 */
	@TableField("MODULE")
	private String module;

	/**
	 * 操作对象
	 */
	@TableField("OPERATE_OBJECT")
	private String operateObject;

	/**
	 * 操作对象类型
	 */
	@TableField("OPERATE_OBJECT_TYPE")
	private String operateObjectType;
}
