package com.cesgroup.bdc.mail.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;
import java.util.Map;

/**
 * <p>
 * 收件信息
 * </p>
 *
 * @author shen.shaohua
 * @since 2019-07-08
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("MAIL_RECEIVE")
public class MailReceive implements Serializable {
	private static final long serialVersionUID = 8549254067364831291L;

	@TableId("ID")
	private String id;

	/**
	 * MAIL_SEND的id
	 */
	@TableField("MAIL_SEND_ID")
	private String mailSendId;

	/**
	 * 收件单位id
	 */
	@TableField("DEPT_ID")
	private String deptId;

	/**
	 * 收件单位
	 */
	@TableField("DEPT_NAME")
	private String deptName;

	/**
	 * 签收状态（1：未签收，2：已签收，3：强制签收）
	 */
	@TableField("STATUS")
	private String status;

	/**
	 * 签收时间
	 */
	@TableField("RECEIVE_DATE")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date receiveDate;

	/**
	 * 签收回执
	 */
	@TableField("REPLY_TEXT")
	private String replyText;

	/**
	 * 签收人id
	 */
	@TableField("RECEIVE_USER_ID")
	private String receiveUserId;

	/**
	 * 签收人
	 */
	@TableField("RECEIVE_USER_NAME")
	private String receiveUserName;

	/**
	 * 是否延期
	 */
	@TableField("EXTEND_TIME")
	private String extendTime;

	/**
	 * 备注
	 */
	@TableField("REMARK")
	private String remark;

	@TableField(exist = false)
	private Map<String, String> extra;

	@TableField(exist = false)
	private MailSend mailSend;

	/**
	 * 排序号
	 */
	@TableField("SORT_NUMBER")
	private String sortNumber;
}
