package com.cesgroup.bdc.mail.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;
import java.util.Map;

/**
 * <p>
 * 发件信息
 * </p>
 *
 * @author shen.shaohua
 * @since 2019-07-08
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("MAIL_SEND")
public class MailSend implements Serializable {
	private static final long serialVersionUID = 6299940844558595606L;

	@TableId("ID")
	private String id;

	/**
	 * 标题
	 */
	@TableField("MAIL_TITLE")
	private String mailTitle;

	/**
	 * 正文
	 */
	@TableField("MAIL_TEXT")
	private String mailText;

	/**
	 * 发送人id
	 */
	@TableField("USER_ID")
	private String userId;

	/**
	 * 发送人
	 */
	@TableField("USER_NAME")
	private String userName;

	/**
	 * 发送部门id
	 */
	@TableField("DEPT_ID")
	private String deptId;

	/**
	 * 发送部门
	 */
	@TableField("DEPT_NAME")
	private String deptName;

	/**
	 * 发送时间
	 */
	@TableField("SEND_TIME")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date sendTime;

	/**
	 * 文电类型
	 */
	@TableField("MAIL_TYPE")
	private String mailType;

	/**
	 * 密级
	 */
	@TableField("SAFE_LEVEL")
	private String safeLevel;

	/**
	 * 紧急程度
	 */
	@TableField("EMERGENCY")
	private String emergency;

	/**
	 * 会议时间
	 */
	@TableField("PARTY_TIME")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date partyTime;

	/**
	 * 文电页数
	 */
	@TableField("MAIL_PAGE")
	private Integer mailPage;

	/**
	 * 发文号
	 */
	@TableField("MAIL_NO")
	private String mailNo;

	/**
	 * 有效时间（精确到天）
	 */
	@TableField("EFF_DATE")
	@JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd")
	private Date effDate;

	/**
	 * 打印份数
	 */
	@TableField("PRINT_NUM")
	private String printNum;

	/**
	 * 是否提供下载（0：否，1：是）
	 */
	@TableField("CAN_DOWNLOAD")
	private String canDownload;

	/**
	 * 是否重发短信（0：否）
	 */
	@TableField("NEED_MSG")
	private String needMsg;

	/**
	 * 短信内容
	 */
	@TableField("MSG_CONTENT")
	private String msgContent;

	/**
	 * 备注
	 */
	@TableField("REMARK")
	private String remark;
	/**
	 * 签收状态（0: 未完成,1: 完成）
	 */
	@TableField("STATUS")
	private String status;
	/**
	 * 记录原发文id（再次发送时）
	 */
	@TableField("PREVIOUS_ID")
	private String previousId;

	@TableField(exist = false)
	private Map<String, String> extra;

	/**
	 * 签收状态（0: 未完成,1: 完成）
	 */
	@TableField("CAN_STAMP")
	private String canStamp;

	/**
	 * 转发文件的源头单位
	 */
	@TableField("FORWORD_DEPT")
	private String forwordDept;
}
