package com.cesgroup.bdc.print.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 打印记录
 * </p>
 *
 * @author shen.shaohua
 * @since 2019-07-26
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("PRINT_RECORD")
public class PrintRecord implements Serializable {
	private static final long serialVersionUID = -2805403569445279224L;

	@TableField("ID")
	private String id;

	/**
	 * 打印人id
	 */
	@TableField("USER_ID")
	private String userId;

	/**
	 * 打印人名称
	 */
	@TableField("USER_NAME")
	private String userName;

	/**
	 * 打印部门id
	 */
	@TableField("DEPT_ID")
	private String deptId;

	/**
	 * 打印部门名称
	 */
	@TableField("DEPT_NAME")
	private String deptName;

	/**
	 * 打印时间
	 */
	@TableField("PRINT_TIME")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	private Date printTime;

	/**
	 * 附件id
	 */
	@TableField("ATTACHMENT_ID")
	private String attachmentId;

	/**
	 * 收文id
	 */
	@TableField("MAIL_RECEIVE_ID")
	private String mailReceiveId;

}
