package com.cesgroup.bdc.print.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.cesgroup.bdc.print.entity.PrintRecord;
import com.cesgroup.bdc.print.vo.PrintShowVo;
import com.cesgroup.bdc.util.CuiPage;
import com.cesgroup.kingkong.core.security.model.IOrganization;
import com.cesgroup.kingkong.core.security.model.IUser;

import java.util.List;

/**
 * <p>
 * 打印记录 服务类
 * </p>
 *
 * @author shen.shaohua
 * @since 2019-07-26
 */
public interface IPrintRecordService extends IService<PrintRecord> {
	/**
	 * 添加打印记录
	 *
	 * @param user
	 * @param org
	 * @param attachmentId
	 * @param mailReceiveId
	 */
	void addOne(IUser user, IOrganization org, String attachmentId, String mailReceiveId);

	IPage<PrintShowVo> printStatistics(IPage page);

	IPage<PrintShowVo> queryByKeyWords(IPage page, PrintShowVo printShowVo);

	List<PrintShowVo> getAll();
}
