package com.cesgroup.bdc.stamp.controller;

import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.cesgroup.authen4.ws.CoreHttpClientWS;
import com.cesgroup.authen4.ws.entity.Code;
import com.cesgroup.bdc.attachment.entity.Attachment;
import com.cesgroup.bdc.attachment.entity.DiskFile;
import com.cesgroup.bdc.attachment.service.IAttachmentService;
import com.cesgroup.bdc.attachment.service.IDiskFileService;
import com.cesgroup.bdc.mail.entity.MailSend;
import com.cesgroup.bdc.mail.service.IMailSendService;
import com.cesgroup.bdc.stamp.entity.HisStamp;
import com.cesgroup.bdc.stamp.entity.Stamp;
import com.cesgroup.bdc.stamp.entity.UseSealHisInfo;
import com.cesgroup.bdc.stamp.service.IStampService;
import com.cesgroup.bdc.stamp.vo.SealCheckboxVo;
import com.cesgroup.bdc.util.CuiPage;
import com.cesgroup.bdc.util.IpUtil;
import com.cesgroup.bdc.util.PageVo;
import com.cesgroup.kingkong.core.security.model.IOrganization;
import com.cesgroup.kingkong.core.security.model.IUser;
import com.cesgroup.kingkong.core.security.service.AuthsystemService;
import com.cesgroup.kingkong.web.BaseServiceController;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.util.*;

import static com.cesgroup.authen4.ws.CoreHttpClientWS.getCoreHttpClientWS;

/**
 * @Auther:dxd
 * @Date:2022/9/13 17:39
 */
@Controller
@RequestMapping("/stamp")
public class StampController extends BaseServiceController<Stamp, IStampService> {
    @Autowired
    private AuthsystemService authsystemService;

    @Autowired
    private IAttachmentService attachmentService;

    @Autowired
    private IDiskFileService diskFileService;

    @Autowired
    private IMailSendService mailSendService;
    /**
     * 用章申请填写页面
     *
     * @param id
     * @return
     */
    @RequestMapping("/addStamp/{id}")
    public ModelAndView addStamp(@PathVariable String id, HttpSession session) {
        ModelAndView mv = new ModelAndView("stamp/add");
        IOrganization org = getOrg(session);
        mv.addObject("id", id);
        mv.addObject("deptId", org.getId());
        mv.addObject("deptName", org.getName());
        return mv;
    }

    /**
     * 用章申请页面编辑
     *
     * @param execId
     * @return
     */
    @RequestMapping("/editStamp/{execId}/{stId}/{mailSendId}")
    public ModelAndView editStamp(@PathVariable String execId, @PathVariable String stId, @PathVariable String mailSendId, HttpSession session) {
        ModelAndView mv = new ModelAndView("stamp/edit");
        IOrganization org = getOrg(session);
        IUser user = getUser();
        mv.addObject("execId", execId);
        mv.addObject("stId", stId);
        mv.addObject("mailSendId", mailSendId);
        mv.addObject("deptId", org.getId());
        mv.addObject("deptName", org.getName());
        mv.addObject("userId", user.getId());
        return mv;
    }

    /**
     * 外系统跳用章申请页面编辑
     *
     * @param execId
     * @return
     */
    @RequestMapping("/editStamp1/{execId}/{stId}/{mailSendId}/{local}")
    public ModelAndView editStamp1(@PathVariable String execId, @PathVariable String stId, @PathVariable String mailSendId, @PathVariable String local, HttpSession session) {
        ModelAndView mv = new ModelAndView("stamp/editToSwgl");
        IOrganization org = getOrg(session);
        IUser user = getUser();
        mv.addObject("execId", execId);
        mv.addObject("stId", stId);
        mv.addObject("mailSendId", mailSendId);
        mv.addObject("deptId", org.getId());
        mv.addObject("deptName", org.getName());
        mv.addObject("userId", user.getId());
        mv.addObject("local", local);
        return mv;
    }
    /**
     * 外系统跳用章申请页面编辑
     *
     * @param execId
     * @return
     */
    @RequestMapping("/iframe/{execId}/{stId}/{mailSendId}/{local}")
    public ModelAndView iframe(@PathVariable String execId, @PathVariable String stId, @PathVariable String mailSendId, @PathVariable String local, HttpSession session) {
        ModelAndView mv = new ModelAndView("stamp/iframeToSwgl");
        IOrganization org = getOrg(session);
        mv.addObject("execId", execId);
        mv.addObject("stId", stId);
        mv.addObject("mailSendId", mailSendId);
        mv.addObject("local", local);
        mv.addObject("deptId", org.getId());
        return mv;
    }
    /**
     * 根据执行任务id查询单条数据
     *
     * @param execId
     * @return
     */
    @RequestMapping("/selectByExecId/{execId}")
    @ResponseBody
    public HisStamp selectByExecId(@PathVariable String execId, HttpSession session) {
        HisStamp hisStamp = getBaseService().selectByExecId(execId);
        return hisStamp;
    }

    /**
     * 根据任务id查询单条数据
     *
     * @param hpId
     * @return
     */
    @RequestMapping("/selectByhpIdDwld/{hpId}")
    @ResponseBody
    public Map<String, String> selectByhpIdDwld(@PathVariable String hpId) {
        HisStamp hisStamp = getBaseService().selectByhpIdDwld(hpId);
        Map<String, String> mm = new HashMap<>();
        if (hisStamp != null) {
            mm.put("status", "1");
            return mm;
        }else {
            mm.put("status", "0");
            return mm;
        }
    }

    /**
     * 根据执行任务id查询单条数据
     *
     * @param preNodeId
     * @return
     */
    @RequestMapping("/selectByhpIdApply/{preNodeId}")
    @ResponseBody
    public Map<String, String> selectByhpIdApply(@PathVariable String preNodeId) {
        HisStamp hisStamp = getBaseService().selectByhpIdApply(preNodeId);
        Map<String, String> mm = new HashMap<>();
        if (hisStamp.getNodeCode().equals("start")) {
            mm.put("status", "1");
            return mm;
        }else {
            mm.put("status", "0");
            return mm;
        }
    }

    /**
     * 提交
     *
     * @return
     */
    @RequestMapping("/saveStamp")
    @ResponseBody
    public Map<String, String> saveStamp(Stamp entity) throws Exception{
        Map<String, String> mm = this.service.saveStamp(entity);
        return mm;
    }

    /**
     * 审批
     * @param execId
     * @param reason
     * @param stamp
     * @return
     * @throws Exception
     */
    @RequestMapping("/approve")
    @ResponseBody
    public Map<String, String> approve(String execId, String reason, Stamp stamp) throws Exception{
        this.service.approve(execId, reason, stamp);
        Map<String, String> mm = new HashMap<>();
        mm.put("status", "success");
        return mm;
    }

    /**
     * 分页查询跳转
     * @return
     */
    @RequestMapping("/stampApplyList")
    public ModelAndView stampApplyList() {
        ModelAndView mv = new ModelAndView("stamp/stampApplyList");
        return mv;
    }

    /**
     * 分页查询
     * @param pager
     * @param request
     * @return
     */
    @RequestMapping("/stampQueryApplyList")
    @ResponseBody
    public PageVo stampQueryApplyList(CuiPage<HisStamp> pager, HttpServletRequest request) {
        String sendTimeStart = request.getParameter("sendTimeStart");
        String sendTimeEnd = request.getParameter("sendTimeEnd");
        String mailTitle = request.getParameter("mailTitle");
        String status = request.getParameter("status");
        String type = request.getParameter("type");
        PageVo<HisStamp> pv = this.service.stampQueryApplyList(sendTimeStart, sendTimeEnd, mailTitle, status, type, pager);
        return pv;
    }

    /**
     * 根据实例id查看退回原因
     * @param procInstId
     * @return
     */
    @RequestMapping("/backReason")
    @ResponseBody
    public List<Map<String, Object>> stampData(String procInstId) {
        List<Map<String, Object>> reasonList = service.getReason(procInstId);
        return reasonList;
    }

    /**
     * 审批页面跳转
     * @return
     */
    @RequestMapping("/stampApprove")
    public ModelAndView stampApprove() {
        ModelAndView mv = new ModelAndView("stamp/stampApplyList");
        return mv;
    }

    /**
     * 附件页面
     * @param attachId
     * @param nodeCode
     * @param phStatus
     * @param assgineeId
     * @param sealId
     * @param sealName
     * @param stId
     * @param session
     * @return
     */
    @RequestMapping("/updatePrintNum4")
    public ModelAndView updatePrintNum4(@RequestParam("attachId") String attachId, @RequestParam("nodeCode") String nodeCode,
                                        @RequestParam("phStatus") String phStatus, @RequestParam("assgineeId") String assgineeId,
                                        @RequestParam(name = "sealId", required = false) String sealId,
                                        @RequestParam(name = "sealName", required = false) String sealName, String stId, HttpSession session) {
        ModelAndView mv = new ModelAndView("stamp/printForm3");

        IOrganization organization = getOrg(session);
        Stamp stamp = service.getById(stId);
        String sealType = stamp.getSealType();
        StringBuilder sealNames = new StringBuilder();

        String orgCode = organization.getCode();
        String[] selectedSealArray = sealType.split(",");
        for (String sId : selectedSealArray){
            if (sId.startsWith(orgCode.replaceAll("\\.", "_"))){
                Code code = getCodeByCodeKey(sId);
                sealNames.append(code.getName()).append(",");
            }
        }
        if (StringUtils.isNotBlank(sealNames.toString())){
            sealNames = new StringBuilder(sealNames.substring(0, sealNames.length() - 1));
        }

        mv.addObject("attachmentId", attachId);
        mv.addObject("nodeCode", nodeCode);
        mv.addObject("phStatus", phStatus);
        mv.addObject("assgineeId", assgineeId);
        mv.addObject("userId", getUser().getId());
        mv.addObject("sealId", sealId);
        mv.addObject("sealName", sealName);
        mv.addObject("selectNames", sealNames.toString());
        return mv;
    }

    /**
     * 未完成数量
     * @return
     */
    @RequestMapping("/counts")
    @ResponseBody
    public Map<String, Object> counts() {
        Integer wdCount=service.getWdCount();
        Integer yzCount=service.getYzCount();
        Map<String, Object> mm = new HashMap<>();
        mm.put("wdCount",wdCount);
        mm.put("yzCount",yzCount);
        return mm;
    }

    /**
     * 组织名称
     * @param orgId
     * @return
     */
    @RequestMapping("/orgName")
    @ResponseBody
    public IOrganization counts(String orgId) {
        IOrganization organizationById = authsystemService.getOrganizationById(orgId);
        return organizationById;
    }

    /**
     * 删除
     * @param stampIds
     * @return
     */
    @RequestMapping("/deleteStampAndPHis")
    @ResponseBody
    public Map<String, String> deleteStampAndPHis(@RequestParam(value = "stampIds")String stampIds) {
        String[] idArr = StrUtil.split(stampIds, ",");
        for (String stampId : idArr) {
            getBaseService().deleteStampAndPHis(stampId);
        }
        Map<String, String> mm = new HashMap<>();
        mm.put("status", "success");
        return mm;
    }

    /**
     * 根据执行任务id查询单条数据
     *
     * @param sendId
     * @return
     */
    @RequestMapping("/selectBySendId/{sendId}")
    @ResponseBody
    public Map<String, String> selectBySendId(@PathVariable String sendId) {
        QueryWrapper<Stamp> queryWrapper1 = new QueryWrapper<>();
        queryWrapper1.eq("MAIL_SEND_ID", sendId);
        List<Stamp> list = getBaseService().getBaseMapper().selectList(queryWrapper1);
        Map<String, String> mm = new HashMap<>();
        if (list.size()>0) {
            mm.put("status", "1");
            return mm;
        }else {
            mm.put("status", "0");
            return mm;
        }
    }

    /**
     * 根据执行任务id查询单条数据
     *
     * @param sendId
     * @return
     */
    @RequestMapping("/selectBySendId1/{sendId}")
    @ResponseBody
    public List<Stamp> selectBySendId1(@PathVariable String sendId) {
        QueryWrapper<Stamp> queryWrapper1 = new QueryWrapper<>();
        queryWrapper1.eq("MAIL_SEND_ID", sendId);
        List<Stamp> list = getBaseService().getBaseMapper().selectList(queryWrapper1);
        return list;
    }

    /**
     * 标签页加载
     * @return
     */
    @RequestMapping("/tabs")
    public ModelAndView tabs() {
        ModelAndView mv = new ModelAndView("stamp/tabs");
        return mv;
    }

    /**
     * 保存签章信息
     * @return
     */
    @RequestMapping("/addUseSealHisInfo")
    @ResponseBody
    public Map<String, String> addUseSealHisInfo(HttpServletRequest request, HttpSession session){
        String sealIds = request.getParameter("sealIds");
        String[] sealIdsArr = sealIds.split(",");
        String sealNames = request.getParameter("sealNames");
        String[] sealNamesArr = sealNames.split(",");
        for (int i = 0; i < sealIdsArr.length; i++) {
            UseSealHisInfo useSealHisInfo = new UseSealHisInfo();
            IOrganization org = getOrg(session);
            IUser user = getUser();
            useSealHisInfo.setSealOrgId(org.getId());//签章单位ID
            useSealHisInfo.setSealOrgName(org.getName());//签章单位名字
            useSealHisInfo.setSealUserId(user.getId());//签章人ID
            useSealHisInfo.setSealUserName(user.getUserName());//签章人名字
            //附件id
            String attachmentId = request.getParameter("attachmentId");
            //根据附件id获取文件id
            Attachment attachment = attachmentService.getById(attachmentId);
            //文件id
            String diskFileId = attachment.getDiskFileId();
            //根据文件id获取文件信息
            DiskFile diskFile = diskFileService.getById(attachment.getDiskFileId());
            //根据附件关联id获取发文信息
            MailSend mailSendbyId = mailSendService.getById(attachment.getRelevanceId());
            //根据附件关联id获取用章信息
            QueryWrapper<Stamp> queryWrapper = new QueryWrapper();
            queryWrapper.eq("MAIL_SEND_ID",attachment.getRelevanceId());
            Stamp stampbyId = service.getOne(queryWrapper);
            useSealHisInfo.setApplyOrgId(stampbyId.getApplyDeptId());//申请单位id
            useSealHisInfo.setApplyOrgName(stampbyId.getApplyDeptName());//申请单位名称
            useSealHisInfo.setApplyUserId(stampbyId.getApplyPersonId());//申请人id
            useSealHisInfo.setApplyUserName(stampbyId.getApplyPersonName());//申请人名字
            useSealHisInfo.setDocTitle(mailSendbyId.getMailTitle());//签章文件标题
            useSealHisInfo.setFileId(diskFileId);//签章电子文件id
            useSealHisInfo.setFileName(diskFile.getOriginalName());//签章电子文件名称
            useSealHisInfo.setFilePath(diskFile.getPath());//签章电子文件路径
            useSealHisInfo.setOperationIp(IpUtil.getIpAddr(request));//操作人ip地址
            useSealHisInfo.setSealId(sealIdsArr[i]);//印章id
            useSealHisInfo.setSealName(sealNamesArr[i]);//印章名称
            useSealHisInfo.setCreateDate(new Date());//签章时间
            service.addUseSealHisInfo(useSealHisInfo);
        }
        Map<String, String> mm = new HashMap<>();
        mm.put("status", "success");
        return mm;
    }

    /**
     * 根据组织id获取数据字典（只获取下一层子节点）
     * @param orgId
     * @return
     */
    public LinkedHashMap<String, String> querySubCode(String orgId) {

        IOrganization organization = authsystemService.getOrganizationById(orgId);

        CoreHttpClientWS coreHttpClientWS = getCoreHttpClientWS();
        Code code = getCodeByCodeKey(organization.getCode());
        LinkedHashMap<String, String> resultMap = new LinkedHashMap<>();
        if(code != null && StringUtils.isNotBlank(code.getId())) {
            List<Code> codeList = coreHttpClientWS.queryCodeListByParentId(code.getId());
            if(codeList != null && !codeList.isEmpty()) {
                for(Code tCode : codeList) {
                    resultMap.put(tCode.getCodeKey(), tCode.getName());
                }
            }
        }
        return resultMap;
    }

    public Code getCodeByCodeKey(String codeKey){
        CoreHttpClientWS coreHttpClientWS = getCoreHttpClientWS();
        return coreHttpClientWS.queryCodeByCodeKey(codeKey);
    }

    /**
     * 查询部门对应的章
     * @return
     */
    @RequestMapping("/querySealByOrgId")
    @ResponseBody
    public Map<String,Object> querySealByOrgId(String id, String orgIds){
        Map<String, Object> result = new HashMap<>();

        List<SealCheckboxVo> sealCheckboxVoList = new ArrayList<>();

        Stamp sendWorkflow = service.getById(id);

        List<String> checkedSealList = new ArrayList<>();

        if (sendWorkflow != null){
            //获取已选择的印章
            String sealType = sendWorkflow.getSealType();
            if (StringUtils.isNotBlank(sealType)){
                //转为数组
                String[] checkedSealArray = sealType.split(",");
                //转为list
                checkedSealList = Arrays.asList(checkedSealArray);
            }
        }

        if (StringUtils.isNotBlank(orgIds)){
            String[] orgIdArray = orgIds.split(",");

            for (String orgId : orgIdArray){
                SealCheckboxVo sealCheckboxVo = new SealCheckboxVo();
                IOrganization organization = authsystemService.getOrganizationById(orgId);
                sealCheckboxVo.setOrgId(organization.getId());
                sealCheckboxVo.setOrgName(organization.getName());

                LinkedHashMap<String, String> sealLinkedHashMap = querySubCode(orgId);
                List<SealCheckboxVo.SealNode> sealNodeList = new ArrayList<>();
                if (sealLinkedHashMap != null){
                    for (Map.Entry<String, String> entry : sealLinkedHashMap.entrySet()){
                        SealCheckboxVo.SealNode sealNode = new SealCheckboxVo.SealNode();
                        sealNode.setValue(entry.getKey());
                        sealNode.setLabel(entry.getValue());
                        sealNode.setChecked(checkedSealList.contains(entry.getKey()));
                        sealNodeList.add(sealNode);
                    }
                }
                sealCheckboxVo.setSealNodes(sealNodeList);
                sealCheckboxVoList.add(sealCheckboxVo);
            }
        }

        result.put("status", "success");
        result.put("data", sealCheckboxVoList);

        return result;
    }

    /**
     * 跳转统计界面
     * @return
     */
    @RequestMapping("/statisticsView")
    public ModelAndView statisticsView(){
        ModelAndView mv=new ModelAndView("/stamp/statisticsList");
        return mv;
    }

    /**
     * 查询部门对应的章
     * @return
     */
    @RequestMapping("/statisticsList")
    @ResponseBody
    public PageVo<Map<String,Object>> statisticsList(CuiPage<HisStamp> pager){
        List<Map<String,Object>> list=new ArrayList();
        for (int i = 0; i < 30; i++) {
            Map<String,Object> map=new HashMap<>();
            map.put("sqdw","测试单位"+i);
            map.put("sqr","张三"+i);
            map.put("dw","签章单位"+i);
            map.put("qzr","李四"+i);
            map.put("qzsj","2022-10-24 10:24:00");
            map.put("qzwjbt","文件标题"+i);
            map.put("qzdzwjmc","电子文件名称"+i);
            map.put("qzdzwjlj","");
            map.put("czdz","");
            map.put("type","部门用章");
            map.put("name","章名"+i);
            list.add(map);
        }
        IPage<Map<String,Object>> p = new Page<>();
        p.setPages(pager.getPages());
        p.setRecords(list.subList(((int)pager.getCurrent()-1)*((int)pager.getSize()),((int)pager.getCurrent())*((int)pager.getSize())>list.size()?list.size():((int)pager.getCurrent())*((int)pager.getSize())));
        p.setTotal(list.size());
        p.setSize(pager.getSize());
        p.setCurrent(pager.getCurrent());
        PageVo<Map<String,Object>> pv = PageVo.<Map<String,Object>>convertFromMybatisplusPage(p);
        return pv;
    }

    /**
     * 查询部门对应的章
     * @return
     */
    @RequestMapping("/downloadFiles")
    public void downloadFiles(HttpServletRequest request, HttpServletResponse response){
        service.download(request,response);
    }

}
