package com.cesgroup.bdc.stamp.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @Auther:dxd
 * @Date:2022/9/14 15:40
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("HIS_STAMP")
public class HisStamp implements Serializable {

    @TableField("S_ID")
    private String stId;

    /**
     * 实例id
     */
    @TableField("S_PROC_INST_ID")
    private String sProcInstId;

    /**
     * 发文信息id
     */
    @TableField("MAIL_SEND_ID")
    private String mailSendId;

    /**
     * 申请时间时间
     */
    @TableField("SQ_TIME")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+8")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private Date sqTime;

    /**
     * 用章理由
     */
    @TableField("YZ_REASON")
    private String yzReason;

    /**
     * 申请人id
     */
    @TableField("APPLY_PERSON_ID")
    private String applyPersonId;

    /**
     * 申请人
     */
    @TableField("APPLY_PERSON_NAME")
    private String applyPersonName;

    /**
     * 申请部门id
     */
    @TableField("APPLY_DEPT_ID")
    private String applyDeptId;

    /**
     * 申请部门
     */
    @TableField("APPLY_DEPT_NAME")
    private String applyDeptName;

    /**
     * 标题
     */
    @TableField("MAIL_TITLE")
    private String mailTitle;

    /**
     * 用章参与部门
     */
    @TableField("YZ_DEPT")
    private String receiveDept;

    /**
     * 状态
     */
    @TableField("S_STATUS")
    private String stStatus;

    /**
     * 发文号
     */
    @TableField("MAIL_NO")
    private String mailNo;

    /**
     * 外单位ID
     */
    @TableField("WDW_DEPT_ID")
    private String wdwDeptId;

    /**
     * 类型
     */
    @TableField("TYPE")
    private String type;

    /**
     * 密级
     */
    @TableField("SAFE_LEVEL")
    private String safeLevel;

    /**
     * id
     */
    @TableField("P_ID")
    private String hpId;

    /**
     * 流程实例id
     */
    @TableField("PROC_INST_ID")
    private String procInstId;

    /**
     * 流程定义id
     */
    @TableField("PROC_DEF_ID")
    private String procDefId;

    /**
     * 上一个节点id，如果是并行任务，存的是最后一个完成任务的id，
     * 如果由此节点做了退回操作，则此参数设置为空
     */
    @TableField("PRE_NODE_ID")
    private String preNodeId;

    /**
     * 流程节点code
     */
    @TableField("NODE_CODE")
    private String nodeCode;

    /**
     * 流程节点名称
     */
    @TableField("NODE_NAME")
    private String nodeName;

    /**
     * 执行id，可能是任务id，可能是后续其他节点的id
     */
    @TableField("EXEC_ID")
    private String execId;

    /**
     * 任务开始时间
     */
    @TableField("START_TIME")
    private String startTime;

    /**
     * 任务完成时间
     */
    @TableField("END_TIME")
    private String endTime;

    /**
     * 任务状态
     */
    @TableField("P_STATUS")
    private String phStatus;

    /**
     * 受托人id
     */
    @TableField("ASSGINEE_ID")
    private String assgineeId;

    /**
     * 受托人名
     */
    @TableField("ASSGINEE_NAME")
    private String assgineeName;

    /**
     * 受托人组织id
     */
    @TableField("ASSGINEE_ORG_ID")
    private String assgineeOrgId;

    /**
     * 处理人id
     */
    @TableField("HANDLER_ID")
    private String handlerId;

    /**
     * 处理人名称
     */
    @TableField("HANDLER_NAME")
    private String handlerName;

    /**
     * 处理人组织id
     */
    @TableField("HANDLER_ORG_ID")
    private String handlerOrgId;

}
