package com.cesgroup.bdc.stamp.entity;


import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;
import org.springframework.format.annotation.DateTimeFormat;

import java.io.Serializable;
import java.util.Date;

/**
 * @Auther:dxd
 * @Date:2022/10/21 15:40
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@TableName("USE_SEAL_HIS_INFO")
public class UseSealHisInfo implements Serializable {
  private static final long serialVersionUID = 6299940844558595606L;

  /**
   * ID
   */
  @TableId(value = "ID",type = IdType.ID_WORKER_STR)
  private String id;

  /**
   * 申请单位ID
   */
  @TableField("APPLY_ORG_ID")
  private String applyOrgId;

  /**
   * 申请单位名称
   */
  @TableField("APPLY_ORG_NAME")
  private String applyOrgName;

  /**
   *申请人ID
   */
  @TableField("APPLY_USER_ID")
  private String applyUserId;

  /**
   *申请人姓名
   */
  @TableField("APPLY_USER_NAME")
  private String applyUserName;

  /**
   *签章单位ID
   */
  @TableField("SEAL_ORG_ID")
  private String sealOrgId;

  /**
   *签章单位名称
   */
  @TableField("SEAL_ORG_NAME")
  private String sealOrgName;

  /**
   *签章人ID
   */
  @TableField("SEAL_USER_ID")
  private String sealUserId;

  /**
   *签章人姓名
   */
  @TableField("SEAL_USER_NAME")
  private String sealUserName;

  /**
   *签章文件标题
   */
  @TableField("DOC_TITLE")
  private String docTitle;

  /**
   *签章电子文件id
   */
  @TableField("FILE_ID")
  private String fileId;

  /**
   *签章电子文件名称
   */
  @TableField("FILE_NAME")
  private String fileName;

  /**
   *签章电子文件路径
   */
  @TableField("FILE_PATH")
  private String filePath;

  /**
   *操作人ip地址
   */
  @TableField("OPERATION_IP")
  private String operationIp;

  /**
   *印章id
   */
  @TableField("SEAL_ID")
  private String sealId;

  /**
   *印章名称
   */
  @TableField("SEAL_NAME")
  private String sealName;

  /**
   *签章时间
   */
  @TableField("CREATE_DATE")
  @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
  @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
  private Date createDate;

}
