package com.cesgroup.bdc.suwell.controller;

import com.cesgroup.bdc.suwell.service.SuwellService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.Map;

@Controller
@RequestMapping("/suwell")
public class SuwellController {
  @Autowired
  private SuwellService suwellService;

  /**
   * 数科ofd在线浏览
   */
  @RequestMapping("/read")
  public String read() {
    return "suwell/read";
  }

  /**
   * 测试
   */
  @RequestMapping("/test1")
  public String test1() {
    return "suwell/test1";
  }

  /**
   * 将单个办公文件（Office文件如doc等、版式文件如pdf、xps等）转换为OFD文件
   */
  @RequestMapping("/officeToOFD")
  @ResponseBody
  public Map<String, String> officeToOFD(String source, String target) {
    Map<String, String> mm = new HashMap<>();
    boolean b = suwellService.officeToOFD(source, target);
    if (b) {
      mm.put("status", "success");
    } else {
      mm.put("status", "fail");
    }
    return mm;
  }

  /**
   * 添加图片水印
   *
   * @param request
   * @return
   */
  @RequestMapping("/addImageMark")
  @ResponseBody
  public Map<String, String> addImageMark(HttpServletRequest request) {
    Map<String, String> mm = new HashMap<>();
    String srcFilePath = request.getParameter("srcFilePath");
    String targetFilePath = request.getParameter("targetFilePath");
    String imgPath = request.getParameter("imgPath");
    int x = Integer.parseInt(request.getParameter("x"));
    int y = Integer.parseInt(request.getParameter("y"));
    boolean b = suwellService.addImageMark(srcFilePath, targetFilePath, imgPath, x, y, new int[]{1});
    if (b) {
      mm.put("status", "success");
    } else {
      mm.put("status", "fail");
    }
    return mm;
  }

  /**
   * 转pdf
   *
   * @param request
   * @return
   */
  @RequestMapping("/officeToPdf")
  @ResponseBody
  public Map<String, String> officeToPdf(HttpServletRequest request) {
    Map<String, String> mm = new HashMap<>();
    String srcFilePath = request.getParameter("srcFilePath");
    String targetFilePath = request.getParameter("targetFilePath");
    boolean b = suwellService.OFDToPDF(srcFilePath, targetFilePath);
    if (b) {
      mm.put("status", "success");
    } else {
      mm.put("status", "fail");
    }
    return mm;
  }
}
