package com.cesgroup.bdc.wdgl.controller;

import com.cesgroup.bdc.wdgl.vo.ConditionVo;
import com.cesgroup.kingkong.core.security.model.IUser;
import org.apache.shiro.SecurityUtils;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

@Controller
@RequestMapping("/wdgl")
public class WdglController {
	private IUser getUser() {
		IUser currentUser = (IUser) SecurityUtils.getSubject().getPrincipal();
		return currentUser;
	}

	/**
	 * 文电管理页面
	 *
	 * @return
	 */
	@RequestMapping("/index")
	public ModelAndView wdgl() {
		ModelAndView mv = new ModelAndView("wdgl/index");
		return mv;
	}

	/**
	 * 文电管理查询列表页面
	 *
	 * @author: shen.shaohua
	 * @since: 2019/7/15 11:21
	 */
	@RequestMapping("/toQuery/{type}")
	public ModelAndView toQuery(@PathVariable String type, ConditionVo conditionVo) {
		ModelAndView mv = new ModelAndView();
		if ("fw".equals(type)) { //发文管理
			mv.setViewName("mailSend/toQuery");
		} else if ("sw".equals(type)) { //收文管理
			mv.setViewName("mailReceive/toQuery");
		}
		mv.addObject("conditionVo", conditionVo);
		return mv;
	}
}
