package com.cesgroup.bdc.wfself.config;

import com.cesgroup.bdc.wfself.def.CommonProcDef;
import com.cesgroup.bdc.wfself.demo.StampApply;
import com.cesgroup.bdc.wfself.engine.service.WorkflowDao;
import com.cesgroup.bdc.wfself.engine.service.impl.ProcInstEngineService;
import com.cesgroup.bdc.wfself.engine.service.impl.TaskService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.HashMap;
import java.util.Map;

/**
 * 工作流配置类
 * @author BeiLang
 */
@Configuration
public class WorkflowConfig {

    @Autowired
    private WorkflowDao workflowDao;

    @Bean
    public TaskService taskService() {
        TaskService taskService = new TaskService();
        taskService.setWorkflowDao(workflowDao);
        return taskService;
    }

    @Bean
    public ProcInstEngineService procInstEngineService() {
        Map<String, CommonProcDef> procDefMap = new HashMap<>(1);
        procDefMap.put(sendSealProcDef().getProcDefId(), sendSealProcDef());
        ProcInstEngineService procInstEngineService = new ProcInstEngineService(procDefMap);
        procInstEngineService.setWorkflowDao(workflowDao);
        procInstEngineService.setTaskService(taskService());
        return procInstEngineService;
    }

    @Bean
    public CommonProcDef sendSealProcDef() {
        return new StampApply();
    }
}
