package com.cesgroup.bdc.wfself.engine.service.impl;

import java.util.Map;

import com.cesgroup.bdc.wfself.def.CommonProcDef;
import com.cesgroup.bdc.wfself.engine.service.IProcEngineService;
import com.cesgroup.bdc.wfself.node.event.StartEvent;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * 流程引擎
 *
 * @author khaoth
 */
public class ProcInstEngineService extends ProcHandleService implements IProcEngineService {

    private TaskService taskService;

    public ProcInstEngineService(Map<String, CommonProcDef> procDefMap) {
        this.setProcDef(procDefMap);
    }

    public void setTaskService(TaskService taskService) {
        taskService.setProcDef(this.getProcDef());
        this.taskService = taskService;
    }

    @Override
    public TaskService getTaskService() {
        return this.taskService;
    }

    /**
     * 启动流程：
     */
    @Override
    public String startProcess(String procDefId, String userId, Map<String, String> paramMap) throws Exception {
        // 获取流程定义对象
        CommonProcDef procDef = this.getProcDef(procDefId);
        // 流程开始节点对象
        StartEvent startEvent = procDef.getStartEvent();
        // 开始节点事件处理
        // 返回流程实例id
        return startEventHandle(procDefId, startEvent, userId, paramMap);
    }
}
