package com.cesgroup.bdc.wfself.node.gateway;

import com.cesgroup.bdc.wfself.def.CommonNode;
import com.cesgroup.bdc.wfself.def.IGateway;
import com.cesgroup.bdc.wfself.def.INode;

import java.util.List;

/**
 * 并行网关
 * 
 * @author khaoth
 */
public class ParaGateway extends CommonNode implements IGateway {

    public ParaGateway() {}

    /**
     * 是否为合并节点
     */
    private boolean isMerge = false;
    
    /**
     * 分支编码，当时合并节点时才会有至。
     */
    private String branshCode = null;

    /**
     * 构造函数
     * 
     * @param code
     *            节点code
     * @param name
     *            节点名称
     */
    public ParaGateway(String code, String name) {
        super(code, name);
    }

    /**
     * 构造函数
     * 
     * @param code
     *            节点code
     * @param name
     *            节点名称
     * @param isMerge
     *            是否为合并节点
     */
    public ParaGateway(String code, String name, boolean isMerge, String branshCode) {
        super(code, name);
        this.isMerge = isMerge;
        this.branshCode = branshCode;
    }

    /**
     * 获取是否聚合节点
     * 
     * @return
     */
    public boolean isMerge() {
        return isMerge;
    }

    /**
     * 获取分支编码
     * @return
     */
    public String getBranshCode() {
        return branshCode;
    }

    /**
     * 并行网关聚合条件
     * 
     * @param nodeList
     *            已完成任务的节点list
     * @return
     */
    public INode condition(List<INode> nodeList) {
        
        if(nodeList != null && !nodeList.isEmpty()) {
            
        }
        return null;
    }
}
