<%--
  since: 2019/7/18 9:42
  author: shen.shaohua
  description: 延期申请页面
  url: ${ctx}/expire-apply/add/{mailReceiveId}
--%>
<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
	pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
%>
<cui:layout id="layout${idSuffix}" fit="true">
	<cui:layoutRegion region="center">
		<cui:form id="form${idSuffix}" heightStyle="fill" style="padding: 0px;">
			<input type="hidden" name="mailReceiveId" value="${mailReceiveId}"/>
			<div style="text-align: center;width: 450px;margin: 0px auto;">
				<div style="text-align: left;margin-top: 30px;height: 40px;">
					<div style="float: left;width: 25%;text-align: right;padding-top: 3px;">
						<span class="validate-required">*</span>有效时间：
					</div>
					<div style="float: right;width: 73%;text-align: left;">
						<cui:datepicker name="expireDate" dateFormat="yyyy-MM-dd" width="200" required="true" componentCls="form-control"/>
					</div>
				</div>
				<div style="text-align: left;height: 100px;">
					<div style="float: left;width: 25%;text-align: right;padding-top: 3px;">
						申请原因：
					</div>
					<div style="float: right;width: 73%;text-align: left;">
						<cui:textarea name="applyReason" componentCls="form-control" height="95"></cui:textarea>
					</div>
				</div>
			</div>
		</cui:form>
	</cui:layoutRegion>
	<cui:layoutRegion region="south" style="overflow: hidden;">
		<div class="buttens-foot-tools">
			<a onclick="expireApply_add_sample.sure()">确定</a>
			<a onclick="expireApply_add_sample.colseD()">取消</a>
		</div>
	</cui:layoutRegion>
</cui:layout>
<script type="text/javascript">
	var expireApply_add_fun = (function (win, $) {
		function sample() {
		}

		var $thisDialog = $('#layout${idSuffix}').closest('.ctrl-init-dialog');
		var $form = $('#form${idSuffix}');

		//关闭
		sample.prototype.colseD = function () {
			closeThisDialog();
		}

		//发送
		sample.prototype.sure = function () {
			if (!$form.form('valid')) {
				warning('表单填写不正确！');
				return;
			}
			var formData = $form.form('formData');
			//console.log(formData);
			//return;
			loading('加载中...');
			$.ajax({
				type: 'POST',
				url: '${ctx}/expire-apply/add',
				data: formData,
				dataType: 'json',
				success: function (data) {
					hide();
					if (data.code == '0') {
						message('操作成功！');
					} else if (data.code == '-1') {
						error('操作失败！');
					}
					closeThisDialog();
				},
				error: function (e) {
					hide();
					error(e);
				}
			});
		}

		function closeThisDialog() {
			$thisDialog.dialog('close');
		}

		return sample;
	})(window, $);

	var expireApply_add_sample = new expireApply_add_fun();
	window['expireApply_add_fun'] = null;
	delete window['expireApply_add_fun'];
</script>
