<%--
  since: 2019/7/18 17:16
  author: shen.shaohua
  description: 过期数据申请列表
  url: ${ctx}/expire-apply/applyList
--%>
<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
	pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
%>
<div style="height: 100%;">
	<div class="nav2"><img src="${ctx}/static/cm/image/wdpy-nav.png"/>文电批阅</div>
	<div class="table-head">
		<div class="table-title">过期数据申请</div>
		<%--<div class="table-head-right">
			<a onclick="expireApply_applyList_sample.add()">添加</a>
			<a onclick="expireApply_applyList_sample.del()">删除</a>
		</div>--%>
	</div>
	<cui:grid id="grid${idSuffix}" url="${ctx}/expire-apply/applyListQuery" asyncType="get" postData="expireApply_applyList_sample.postData"
						sortorder="desc" loadonce="false" rownumbers="true" fitStyle="fill" rownumName="序号"
						style="margin-left: 5px;margin-right: 5px;">
		<cui:gridCols>
			<cui:gridCol name="id" hidden="true">id</cui:gridCol>
			<cui:gridCol name="approveResult" hidden="true">审批结果</cui:gridCol>
			<cui:gridCol name="mailSend.mailTitle" formatter="expireApply_applyList_sample.titleFmt">文电标题</cui:gridCol>
			<cui:gridCol name="mailSend.effDate">原有效期</cui:gridCol>
			<cui:gridCol name="expireDate">延期时间</cui:gridCol>
			<cui:gridCol name="applyReason">申请原因</cui:gridCol>
			<cui:gridCol name="applyDate">申请时间</cui:gridCol>
			<cui:gridCol name="approveUserName">审批人</cui:gridCol>
			<cui:gridCol name="approveDeptName">审批单位</cui:gridCol>
			<cui:gridCol name="approveDetail">审批内容</cui:gridCol>
			<cui:gridCol name="approveDate">审批时间</cui:gridCol>
			<cui:gridCol name="status" formatter="expireApply_applyList_sample.statusFmt" align="center">当前状态</cui:gridCol>
		</cui:gridCols>
		<cui:gridPager gridId="grid${idSuffix}"/>
	</cui:grid>
</div>
<cui:dialog id="dialogA${idSuffix}" modal="true" autoOpen="false" reLoadOnOpen="true"
						focusInput="false" resizable="true" autoDestroy="true" maximized="false"></cui:dialog>
<script type="text/javascript">
	var expireApply_applyList_fun = (function (win, $) {
		function sample() {
			this.postData = {
				descs: 't.APPLY_DATE'
			}
		}

		var $grid = $('#grid${idSuffix}');

		//刷新列表
		sample.prototype.reloadGrid = function () {
			$grid.grid('reload');
		}

		sample.prototype.titleFmt = function (cellValue, options, rowObject) {
			var result = '<a onclick="expireApply_applyList_sample.view(\'' + rowObject.mailReceiveId + '\')">' + cellValue + '</a>';
			return result;
		}

		sample.prototype.statusFmt = function (cellValue, options, rowObject) {
			var result = '';
			var status = rowObject.approveResult;
			if (status == '0') {
				result = '未审批';
			} else if (status == '1') {
				result = '审批通过';
			} else if (status == '2') {
				result = '<span style="color: red;">审批不通过</span>';
			} else {
				result = status;
			}
			return result;
		}

		//查看
		sample.prototype.view = function (mailReceiveId) {
			var url = '${ctx}/mail-receive/view/' + mailReceiveId;
			$('#dialogA${idSuffix}').dialog('option', {
				url: url,
				title: '查看',
				asyncType: 'get',
				width: 1000,
				height: 550,
				buttons: null
			}).dialog('open');
		}

		return sample;
	})(window, $);

	var expireApply_applyList_sample = new expireApply_applyList_fun();
	window['expireApply_applyList_fun'] = null;
	delete window['expireApply_applyList_fun'];
</script>
