<%--
  since: 2019/7/18 17:16
  author: shen.shaohua
  description: 过期数据申请列表
  url: ${ctx}/expire-apply/applyList
--%>
<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
    pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
%>
<div style="height: 100%;">
    <div class="nav2"><img src="${ctx}/static/cm/image/wdpy-nav.png"/>过期数据查询</div>
    <cui:form id="queryForm${idSuffix}" method="post" style="padding-left:10px;padding-top: 10px;margin: 0px;height: 90px;">
        <%--<cui:input id="orgCode" name="orgCode" type="hidden" value="${orgCode}" />--%>
    <div>
                <label>文电标题:</label>
                <cui:input id="mailTitle" name="mailTitle" type="text" width="180" placeholder=""
                               onEnter="logs_index_sample.searchLog"
                               pattern="//^([\u4e00-\u9fa5]|[a-zA-Z0-9])+$//" errMsg="请输入合法字符"/>
                <label>申 请 人:</label>
                <cui:input id="applyUserName" name="applyUserName" type="text" width="180" placeholder=""
                               pattern="//^([\u4e00-\u9fa5]|[a-zA-Z0-9])+$//" errMsg="请输入合法字符"/>
                <label>申请单位:</label>
                <cui:input id="applyDeptName" name="applyDeptName" type="text" width="180" placeholder=""
                               pattern="//^([\u4e00-\u9fa5]|[a-zA-Z0-9])+$//" errMsg="请输入合法字符"/>

                <label>原有效期:</label>
                <cui:datepicker id="effDateS" name="effDateS" dateFormat="yyyy-MM-dd HH:mm:ss"
                                                readonly="false"
                                                width="180" showOn="button"/>
                <label>&nbsp;  至&nbsp&nbsp;</label>
                 <cui:datepicker id="effDateE" name="effDateE" dateFormat="yyyy-MM-dd HH:mm:ss" readonly="false"
                                    width="180"
                                    showOn="button"/>
                <cui:button id="resetSearch" componentCls="sbax_button_yellow" icons="icon-reset" width="80"
                                label="重置"
                                onClick="expireApply_applyList_sample.reset()"/>

    </div>
    <div style="margin-top: 8px;">
                <label> 审 批 人:  </label>
                <cui:input id="approveUserName" name="approveUserName" type="text" width="180" placeholder=""
                               pattern="//^([\u4e00-\u9fa5]|[a-zA-Z0-9])+$//" errMsg="请输入合法字符"/>
                <label>审批时间:</label>
                <cui:datepicker id="approveDateS" name="approveDateS" dateFormat="yyyy-MM-dd HH:mm:ss"
                                    readonly="false"
                                    width="180" showOn="button"/>
                <label>&nbsp;  至&nbsp&nbsp; </span> </label>
                 <cui:datepicker id="approveDateE" name="approveDateE" dateFormat="yyyy-MM-dd HH:mm:ss"
                                    readonly="false"
                                    width="180"
                                    showOn="button"/>
                <label>延期时间:</label>
                 <cui:datepicker id="expireDateS" name="expireDateS" dateFormat="yyyy-MM-dd HH:mm:ss"
                                     readonly="false"
                                     width="180" showOn="button"/>
                <label>&nbsp;  至&nbsp&nbsp;</label>
                <cui:datepicker id="expireDateE" name="expireDateE" dateFormat="yyyy-MM-dd HH:mm:ss"
                                    readonly="false"
                                    width="180"
                                    showOn="button"/>

                <cui:button id="logSearch" componentCls="sbax_button_blue " width="80"
                                icons="icon-search" label="查询"
                                onClick="expireApply_applyList_sample.searchLog"/>

    </div>


    </cui:form>
    <cui:grid id="grid${idSuffix}" url="${ctx}/expire-apply/applyListQuery" asyncType="get"
              postData="expireApply_applyList_sample.postData"
              sortorder="desc" loadonce="false" rownumbers="true" fitStyle="fill" rownumName="序号"
              style="margin-left: 5px;margin-right: 5px;">
        <cui:gridCols>
            <cui:gridCol name="id" hidden="true">id</cui:gridCol>
            <cui:gridCol name="approveResult" hidden="true">审批结果</cui:gridCol>
            <cui:gridCol name="applyUserName">申请人</cui:gridCol>
            <cui:gridCol name="applyDeptName">申请单位</cui:gridCol>
            <cui:gridCol name="mailSend.mailTitle" formatter="expireApply_applyList_sample.titleFmt">文电标题</cui:gridCol>
            <cui:gridCol name="mailSend.effDate">原有效期</cui:gridCol>
            <cui:gridCol name="expireDate">延期时间</cui:gridCol>
            <cui:gridCol name="applyReason">申请原因</cui:gridCol>
            <cui:gridCol name="applyDate">申请时间</cui:gridCol>
            <cui:gridCol name="approveUserName">审批人</cui:gridCol><%--
			<cui:gridCol name="approveDeptName">审批单位</cui:gridCol>
			<cui:gridCol name="approveDetail">审批内容</cui:gridCol>--%>
            <cui:gridCol name="approveDate">审批时间</cui:gridCol>
            <cui:gridCol name="status" formatter="expireApply_applyList_sample.statusFmt"
                         align="center">当前状态</cui:gridCol>
        </cui:gridCols>
        <cui:gridPager gridId="grid${idSuffix}"/>
    </cui:grid>
</div>
<cui:dialog id="dialogA${idSuffix}" modal="true" autoOpen="false" reLoadOnOpen="true"
            focusInput="false" resizable="true" autoDestroy="true" maximized="false"></cui:dialog>
<script type="text/javascript">
    var expireApply_applyList_fun = (function (win, $) {
        function sample() {
            this.postData = {
                descs: 't.APPLY_DATE'
            }
        }

        var $grid = $('#grid${idSuffix}');

        //刷新列表
        sample.prototype.reloadGrid = function () {
            $grid.grid('reload');
        }

        sample.prototype.titleFmt = function (cellValue, options, rowObject) {
            var result = '<a onclick="expireApply_applyList_sample.view(\'' + rowObject.mailReceiveId + '\')">' + cellValue + '</a>';
            return result;
        }

        sample.prototype.statusFmt = function (cellValue, options, rowObject) {
            var result = '';
            var status = rowObject.approveResult;
            if (status == '0') {
                result = '未审批';
            } else if (status == '1') {
                result = '审批通过';
            } else if (status == '2') {
                result = '<span style="color: red;">审批不通过</span>';
            } else {
                result = status;
            }
            return result;
        }

        //查看
        sample.prototype.view = function (mailReceiveId) {
            var url = '${ctx}/mail-receive/view/' + mailReceiveId;
            $('#dialogA${idSuffix}').dialog('option', {
                url: url,
                title: '查看',
                asyncType: 'get',
                width: 1000,
                height: 550,
                buttons: null
            }).dialog('open');
        }

        //重置
        sample.prototype.reset = function () {
            var $form = $('#queryForm${idSuffix}');
            $form.form('clear');
            $form.form('reset');
        }
        //查询
        sample.prototype.searchLog = function () {
            debugger;
            var $form = $('#queryForm${idSuffix}');
            var params = $form.form('formData');
            var $grid = $('#grid${idSuffix}');
            this.postData = params;
            $grid.grid('option', 'postData', params);
            $grid.grid('reload', '${ctx}/expire-apply/queryByKeyWords');
        }

        return sample;
    })(window, $);

    var expireApply_applyList_sample = new expireApply_applyList_fun();
    window['expireApply_applyList_fun'] = null;
    delete window['expireApply_applyList_fun'];
</script>
