<%--
  since: 2019/7/24 15:32
  author: shen.shaohua
  description: 登录日志列表页面
  url: ${ctx}/login-log/index
--%>
<%@ page contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
    pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
%>
<div style="height: 100%;">
    <div class="nav2"><img src="${ctx}/static/cm/image/xtgl-nav.png"/>登录日志</div>
    <cui:form id="queryForm${idSuffix}" method="post" style="padding-left: 10px;height: 50px;">
        <div>
            <label> 姓名：</label>

            <cui:input type="text" name="userName" componentCls="form-control" width="150"
                       pattern="//^([\u4e00-\u9fa5]|[a-zA-Z0-9])+$//" errMsg="请输入合法字符"/>

            <label>部门：</label>

            <cui:input type="text" name="deptName" componentCls="form-control" width="150"
                       pattern="//^([\u4e00-\u9fa5]|[a-zA-Z0-9])+$//" errMsg="请输入合法字符"/>

            <label> 登录时间：</label>

            <cui:datepicker name="loginTimeBegin" dateFormat="yyyy-MM-dd" width="120"/>
            <span style="padding:0px 8px;">至</span>
            <cui:datepicker name="loginTimeEnd" dateFormat="yyyy-MM-dd" width="120"/>

            <label>登录状况：</label>

            <cui:combobox name="loginStatus" readonlyInput="false" emptyText="请选择" width="150"
                          componentCls="form-control" data="loginLog_index_sample.loginStatusData"/>


            <cui:button id="logSearch" componentCls="sbax_button_blue " width="80"
                        icons="icon-search" label="查询"
                        onClick="loginLog_index_sample.search()"/>
            <cui:button id="resetSearch" componentCls="sbax_button_yellow" icons="icon-reset" width="80"
                        label="重置"
                        onClick="loginLog_index_sample.reset()"/>
           <%-- <a onclick="loginLog_index_sample.search()"><img src="${ctx}/static/cm/image/bicon-cx.png"/>查询</a>
            <a onclick="loginLog_index_sample.reset()"><img src="${ctx}/static/cm/image/bicon-cz.png"/>重置</a>--%>

        </div>
    </cui:form>
    <div class="nav2">登录日志</div>
    <cui:grid id="grid${idSuffix}" url="${ctx}/login-log/indexQuery" asyncType="get"
              postData="loginLog_index_sample.postData"
              sortorder="desc" loadonce="false" rownumbers="true" fitStyle="fill" multiselect="false" altRows="true"
              style="margin-left: 5px;margin-right: 5px;">
        <cui:gridCols>
            <cui:gridCol name="id" hidden="true">id</cui:gridCol>
            <cui:gridCol name="loginStatus" hidden="true">loginStatus</cui:gridCol>
            <cui:gridCol name="deptName">部门名</cui:gridCol>
            <cui:gridCol name="userName" width="50">姓名</cui:gridCol>
            <cui:gridCol name="ip" width="60">IP</cui:gridCol>
            <cui:gridCol name="loginTime" width="80">登录时间</cui:gridCol>
            <cui:gridCol name="logDetail">内容</cui:gridCol>
            <cui:gridCol name="status" width="40" formatter="loginLog_index_sample.statusFmt">登录状况</cui:gridCol>
        </cui:gridCols>
        <cui:gridPager gridId="grid${idSuffix}"/>
    </cui:grid>
</div>
<script type="text/javascript">
    var loginLog_index_fun = (function (win, $) {
        var originalPostData = {
            descs: 'LOGIN_TIME'
        };

        function sample() {
            this.postData = originalPostData;

            //登录状况
            this.loginStatusData = [
                {text: '登录成功', value: '1'},
                {text: '登录失败', value: '0'}
            ];
        }

        var $form = $('#queryForm${idSuffix}');
        var $grid = $('#grid${idSuffix}');

        sample.prototype.statusFmt = function (cellValue, options, rowObject) {
            var result = '';
            var loginStatus = rowObject.loginStatus;
            if (loginStatus == '1') {
                result = '登录成功';
            } else if (loginStatus == '0') {
                result = '登录失败';
            } else {
                result = loginStatus;
            }
            return result;
        }

        //搜索
        sample.prototype.search = function () {
            var formData = $form.form('formData');
            this.postData = $.extend(originalPostData, formData);
            $grid.grid('reload', {page: 1});
        }

        //重置
        sample.prototype.reset = function () {
            $form.form('clear');
        }

        return sample;
    })(window, $);

    var loginLog_index_sample = new loginLog_index_fun();
    window['loginLog_index_fun'] = null;
    delete window['loginLog_index_fun'];
</script>

