<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
    pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
%>
<div style="height: 100%;">
    <div class="nav2"><img src="${ctx}/static/cm/image/fjj-nav.png"/>操作日志</div>
    <cui:form id="logsForm${idSuffix}" method="post" style="padding-left: 10px;height: 50px;">
        <%--<cui:input id="orgCode" name="orgCode" type="hidden" value="${orgCode}" />--%>
        <div>
            <label>姓名:</label>
            <cui:input id="userName" name="userName" type="text" width="150" placeholder=""
                       onEnter="logs_index_sample.searchLog"
                       pattern="//^([\u4e00-\u9fa5]|[a-zA-Z0-9])+$//" errMsg="请输入合法字符"/>
           <label>部门名:</label>
            <cui:input id="orgName" name="orgName" type="text" width="150" placeholder=""
                       pattern="//^([\u4e00-\u9fa5]|[a-zA-Z0-9])+$//" errMsg="请输入合法字符"/>
                <%--	<cui:combobox id="logType" name="logType" data="logs_index_sample.logTypeData" width="120" emptyText="全部"
                                                value=""/>--%>
            <label>操作时间:</label>
            <cui:datepicker id="startTime" name="startTime" dateFormat="yyyy-MM-dd HH:mm:ss" readonly="false"
                            width="150" showOn="button"/>
            <label>至</label>
            <cui:datepicker id="endTime" name="endTime" dateFormat="yyyy-MM-dd HH:mm:ss" readonly="false" width="150"
                            showOn="button"/>
            <label>操作内容:</label>
            <cui:combobox id="logType" name="logType" data="logs_index_sample.log_statusData" width="150" emptyText="全部"
                          value=""/>
                <%--<label>状态:</label>--%>

            <cui:button id="logSearch" componentCls="sbax_button_blue " width="80"
                                                icons="icon-search" label="查询"
                                                onClick="logs_index_sample.searchLog"/>
            &nbsp;<cui:button id="resetSearch" componentCls="sbax_button_yellow" icons="icon-reset" width="80"
                              label="重置"
                              onClick="logs_index_sample.reset()"/>
        </div>

    </cui:form>
    <div class="nav2">操作日志</div>
    <cui:grid id="logsGrid${idSuffix}" url="${ctx}/logs/query" asyncType="get" postData="logs_index_sample.logsArgData"
              sortorder="desc" loadonce="false" rownumbers="true" fitStyle="fill" multiselect="false" altRows="true"
              style="margin-left: 5px;margin-right: 5px;">

        <cui:gridCols>
            <cui:gridCol name="id" hidden="true">id</cui:gridCol>
            <cui:gridCol name="userId" hidden="true">操作用户id</cui:gridCol>
            <cui:gridCol name="userName" width="60">姓名</cui:gridCol>
            <cui:gridCol name="orgName" width="60">单位</cui:gridCol>
            <cui:gridCol name="ip" width="60">IP</cui:gridCol>
            <cui:gridCol name="operate" width="100" formatter="logs_index_sample.titleFmt">操作内容</cui:gridCol>
            <cui:gridCol name="createTime" width="60">操作时间</cui:gridCol>
            <cui:gridCol name="status" width="40" formatter="logs_index_sample.statusFmt">操作状态</cui:gridCol>
            <%--
                        <cui:gridCol name="status" width="40" formatter="logs_index_sample.log_statusFormat">状态</cui:gridCol>
            --%>
            <%--	<cui:gridCol name="createTime" width="100">操作时间</cui:gridCol>
                <cui:gridCol name="url" width="80" hidden="true">url</cui:gridCol>--%>
        </cui:gridCols>
        <cui:gridPager gridId="logsGrid${idSuffix}"/>
    </cui:grid>
</div>
<script type="text/javascript">
    var logs_index_fun = (function (win, $) {
        function sample() {
            this.logsArgData = {
                //P_orders: 'createTime,DESC'
                descs: 'create_time'
            }

            this.log_statusData = [
                {'value': '添加', 'text': '添加'},
                {'value': '修改', 'text': '修改'},
                {'value': '查询', 'text': '查询'},
                {'value': '错误', 'text': '错误'},
                {'value': '删除', 'text': '删除'},
                {'value': '打印', 'text': '打印'},
                {'value': '下载', 'text': '下载'}
            ];


        }


        sample.prototype.searchLog = function () {
            debugger;
            var $form = $('#logsForm${idSuffix}');
            var params = $form.form('formData');
            var $grid = $('#logsGrid${idSuffix}');
            this.logsArgData = params;
            $grid.grid('option', 'postData', params);
            $grid.grid('reload', '${ctx}/logs/queryByKeyWords');
        }


        sample.prototype.titleFmt = function (cellValue, options, rowObject) {
            var result = rowObject.operate;
            var from1 = result.indexOf('中');
            var title1 = result.indexOf('=');
            var start = result.substring(0, from1 + 1);
            var op = '<span style="color: #0069b4;">' + result.substring(from1 + 1, from1 + 3) + '</span>';
            var midd = result.substring(from1 + 3, title1 + 1);
            var title = '<span style="color: #0069b4;">' + result.substring(title1 + 1, result.length) + '</span>';
            return start + op + midd + title;
        }


        sample.prototype.statusFmt = function (cellValue, options, rowObject) {
            var result = rowObject.status;
            if (result == '成功') {
                result = '<span style="color: green;">' + result + '</span>';
            } else {
                result = '<span style="color: red;">' + result + '</span>';
            }
            return result;
        }
        //重置
        sample.prototype.reset = function () {
            var $form = $('#logsForm${idSuffix}');
            $form.form('clear');
            $form.form('reset');
        }

        return sample;
    })(window, $);

    var logs_index_sample = new logs_index_fun();
    window['logs_index_fun'] = null;
    delete window['logs_index_fun'];
</script>

