<%--
  since: 2019/7/8 17:59
  author: shen.shaohua
  description: 添加发文页面(分保备份之前版本=》附件标密功能)
  url: ${ctx}/mail-send/add
--%>
<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<%@ page import="cn.hutool.core.date.DateUtil" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%@ page import="com.cesgroup.bdc.util.PrimaryKey" %>
<%
    pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
    pageContext.setAttribute("today", DateUtil.today());
    pageContext.setAttribute("attachmentModule", "mail");
    String relevanceId = PrimaryKey.tempId();
    pageContext.setAttribute("relevanceId", relevanceId);
%>
<style type="text/css">
    #fileUpload${idSuffix}_queueID {
        display: none;
    }

    #fileBtn${idSuffix} {
        background: none;
        background-color: transparent;
        border: none;
        color: red;
    }

    #fileBtn${idSuffix} .coral-button-text {
        padding: 0px;
    }
</style>
<cui:layout id="layout${idSuffix}" fit="true">
    <cui:layoutRegion region="center">
        <cui:form id="form${idSuffix}" heightStyle="fill" style="padding: 0px;">
            <input type="hidden" name="id" id="id${idSuffix}"/>
            <div style="width: 100%;margin: 0px auto;">
                <div class="form-wrap2">
                    <table class="form-table" cellpadding="0" cellspacing="0">
                        <tr>
                            <td width="25%" class="td-width"></td>
                            <td class="td-width"></td>
                        </tr>
                        <tr>
                            <th class="table-head" colspan="2">属性相关</th>
                        </tr>
                        <tr>
                            <th><span class="validate-required">*</span>文电类型</th>
                            <td>
                                <cui:combobox name="mailType" readonlyInput="false" emptyText="-请选择-"
                                              width="200" data="mailSend_add_sample.mailTypeData" required="true"/>
                            </td>
                        </tr>
                        <tr>
                            <th>密级</th>
                            <td>
                                <cui:combobox name="safeLevel" readonlyInput="false"
                                              width="200" data="mailSend_add_sample.safeLevelData"/>
                            </td>
                        </tr>
                        <tr>
                            <th>紧急度</th>
                            <td>
                                <cui:combobox name="emergency" readonlyInput="false"
                                              width="200" data="mailSend_add_sample.emergencyData"/>
                            </td>
                        </tr>
                        <tr>
                            <th>会议时间</th>
                            <td>
                                <cui:datepicker name="partyTime" dateFormat="yyyy-MM-dd HH:mm:ss" width="200"
                                                minDate="${today}"/>
                            </td>
                        </tr>
                        <tr>
                            <th><span class="validate-required">*</span>有效时间</th>
                            <td>
                                <cui:datepicker name="effDate" dateFormat="yyyy-MM-dd" width="200" required="true"
                                                readonlyInput="true" minDate="${today}"/>
                            </td>
                        </tr>
                        <tr>
                            <th><span class="validate-required">*</span>打印份数</th>
                            <td>
                                <cui:input type="text" name="printNum" validType="naturalnumber" width="200"
                                           required="true" value="10"/>
                            </td>
                        </tr>
                        <tr>
                            <th>文电页数</th>
                            <td>
                                <cui:input type="text" name="mailPage" validType="naturalnumber" width="200"/>
                            </td>
                        </tr>
                        <tr>
                            <th>是否提供下载</th>
                            <td>
                                <cui:radiolist name="canDownload" repeatLayout="flow"
                                               data="mailSend_add_sample.canDownloadData"/>
                            </td>
                        </tr>
                    </table>
                </div>
                <div class="form-wrap2" style="padding-left: 1px;">
                    <table class="form-table" cellpadding="0" cellspacing="0">
                        <tr>
                            <td width="20%" class="td-width"></td>
                            <td class="td-width"></td>
                        </tr>
                        <tr>
                            <th class="table-head" colspan="2">内容相关</th>
                        </tr>
                        <tr>
                            <th>发文号</th>
                            <td>
                                <cui:input name="mailNo" componentCls="form-control"/>
                            </td>
                        </tr>
                        <tr>
                            <th><span class="validate-required">*</span>标题</th>
                            <td>
                                <cui:input name="mailTitle" componentCls="form-control" required="true"/>
                            </td>
                        </tr>
                        <tr>
                            <th>正文</th>
                            <td>
                                <cui:textarea name="mailText" componentCls="form-control" height="63"></cui:textarea>
                            </td>
                        </tr>
                        <tr>
                            <th>
                                <a style="color: #ff0000" onclick="mailSend_add_sample.jsdwPicker()">
                                    <span class="validate-required">*</span>接收单位
                                </a>
                            </th>
                            <td>
                                <input type="hidden" name="receiveDept" id="receiveDept${idSuffix}"/>
                                <cui:textarea id="deptNames${idSuffix}" componentCls="form-control" readonly="true"
                                              required="true" cls="cm-readonly" height="60"/>
                            </td>
                        </tr>
                        <tr>
                            <th>
                                <cui:fileuploader id="fileUpload${idSuffix}" uploadBtn="#fileBtn${idSuffix}"
                                                  url="${ctx}/attachment/upload/${attachmentModule}/${relevanceId}"
                                                  maxFileSize="100000kb" acceptFileTypes="*.*"
                                                  autoUpload="true" required="true" multiple="true"
                                                  uploadBtnOptions="{label: '添加附件'}"
                                                  onSuccess="mailSend_add_sample.uploadOnSuccess"
                                                  onStart="loading('正在上传，请稍候...')" onComplete="hide()">
                                    <span id="fileBtn${idSuffix}"></span>
                                </cui:fileuploader>
                            </th>
                            <td style="padding: 0px;">
                                <div id="fileList${idSuffix}"
                                     style="height: 105px;overflow: auto;background-color: #ffffff;margin: 2px;border: 1px solid #4d4d4d;">
                                        <%--<div style="height: 500px;width: 30px;background-color: red;"></div>--%>
                                </div>
                            </td>
                        </tr>
                    </table>
                </div>
            </div>
        </cui:form>
    </cui:layoutRegion>
    <cui:layoutRegion region="south" style="overflow: hidden;">
        <div class="buttens-foot-tools">
            <a onclick="mailSend_add_sample.send()">发送</a>
            <a onclick="mailSend_add_sample.colseD()">关闭</a>
        </div>
    </cui:layoutRegion>
</cui:layout>
<cui:dialog id="dialogB${idSuffix}" modal="true" autoOpen="false" resizable="true"
            autoDestroy="true" reLoadOnOpen="true" maximized="false"></cui:dialog>
<script type="text/javascript">
    var mailSend_add_fun = (function (win, $) {
        function sample() {
            //文电类型
            this.mailTypeData = [
                {text: '文件', value: '文件'},
                {text: '简报', value: '简报'},
                {text: '会议通知', value: '会议通知'},
                {text: '一般通知', value: '一般通知'},
                {text: '信息', value: '信息'},
            ];

            //密级
            this.safeLevelData = [
                {text: '无', value: '无', selected: true},
                {text: '秘密', value: '秘密'},
                {text: '机密', value: '机密'}
            ];

            //紧急度
            this.emergencyData = [
                {text: '无', value: '无', selected: true},
                {text: '平急', value: '平急'},
                {text: '加急', value: '加急'},
                {text: '特急', value: '特急'},
                {text: '特提', value: '特提'}
            ];

            this.canDownloadData = [
                {text: '是', value: '1', checked: true},
                {text: '否', value: '0'}
            ];
        }

        var $thisDialog = $('#layout${idSuffix}').closest('.ctrl-init-dialog');
        var $form = $('#form${idSuffix}');

        var selectDepts = [];//已选单位

        //关闭
        sample.prototype.colseD = function () {
            closeThisDialog();
        }

        //发送
        sample.prototype.send = function () {
            if (!$form.form('valid')) {
                warning('表单填写不正确！');
                return;
            }
            var formData = $form.form('formData');
            formData.tempRelevanceId = '${relevanceId}';
            console.log(formData);
            //return;
            loading('发送中...');
            $.ajax({
                type: 'POST',
                url: '${ctx}/mail-send/send',
                data: formData,
                dataType: 'json',
                success: function (data) {
                    hide();
                    if (data.status == 'success') {
                        message('发送成功！');
                    }
                    mailSend_list_sample.reloadGrid();
                    closeThisDialog();
                },
                error: function (e) {
                    hide();
                    error(e);
                }
            });
        }

        function closeThisDialog() {
            $thisDialog.dialog('close');
        }

        sample.prototype.printAttachment = function (attachId, mailReceiveId) {
            var url = '${ctx}/print-num/updatePrintNum3?attachId=' + attachId;
            window.open(url);
        }

        //选择部门
        sample.prototype.jsdwPicker = function () {
            var url = '${ctx}/auth/selectDept?initfun=mailSend_add_sample.initfun&callback=mailSend_add_sample.deptCallback';
            $('#dialogB${idSuffix}').dialog('option', {
                url: url,
                title: '添加单位',
                asyncType: 'get',
                width: 735,
                height: 565,
                buttons: null
            }).dialog('open');
        }

        //获取已选单位
        sample.prototype.initfun = function () {
            return selectDepts;
        }

        //选择部门回调方法
        sample.prototype.deptCallback = function (selectDeptArray) {
            selectDepts = selectDeptArray;
            var str = JSON.stringify(selectDeptArray);
            $('#receiveDept${idSuffix}').val(str);
            var dd = '';
            $.each(selectDeptArray, function (i, item) {
                if (i > 0) dd += ',';
                dd += item.deptName;
            });
            $('#deptNames${idSuffix}').textbox('setValue', dd);
        }

        //上传附件成功
        sample.prototype.uploadOnSuccess = function (event, ui) {
            /*console.log('event', event);
            console.log('ui', ui);*/
            var file = ui.file;
            var hh = '';
            if (file.ext == 'zip' || file.ext == 'rar' || file.ext == 'ZIP' || file.ext == 'RAR' || file.ext == '7z') {
                hh += '<div class="fileItem" id="upload-' + file.id + '">' +
                    '<a  href="${ctx}/attachment/downloadOriginal/' + file.id + '"    target="_blank">' + file.name + '</a></div>'
            } else {
                hh += '<div class="fileItem" id="upload-' + file.id + '">' +
                    '<a onclick="mailSend_add_sample.printAttachment(\'' + file.id + '\',\'' + '${relevanceId}' + '\')" target="_blank">' + file.name + '</a>' +
                    '<i class="icon-cross2" title="删除" onclick="mailSend_add_sample.delAttachment(\'' + file.id + '\')"></i>' +
                    '</div>'
            }

            $('#fileList${idSuffix}').append(hh);
        }

        sample.prototype.delAttachment = function (id) {
            loading('删除中...');
            $.ajax({
                type: 'DELETE',
                url: '${ctx}/attachment/del/' + id,
                dataType: 'json',
                success: function (data) {
                    hide();
                    //console.log(data, typeof data);
                    if (data == true) {
                        $('#upload-' + id).remove();
                    }
                },
                error: function (e) {
                    hide();
                    error(e);
                }
            });
        }

        return sample;
    })(window, $);

    var mailSend_add_sample = new mailSend_add_fun();
    window['mailSend_add_fun'] = null;
    delete window['mailSend_add_fun'];
</script>
