<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
    pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
%>

<div style="height: 100%;">
    <div class="nav2"><img src="${ctx}/static/cm/image/fjj-nav.png"/>硬件设备录入</div>
    <div class="table-head">
        <div class="table-title">硬件录入设备列表</div>
        <div class="table-head-right">
            <a onclick="driverManage_list_sample.exp()">导出</a>
            <a onclick="driverManage_list_sample.add()">添加</a>
            <a onclick="driverManage_list_sample.edit()">修改</a>
            <a onclick="driverManage_list_sample.del()">删除</a>
        </div>
    </div>
    <cui:grid id="grid${idSuffix}" url="${ctx}/driverManage/queryList" asyncType="get"
              postData="driverManage_list_sample.postData"
              sortorder="desc" loadonce="false" rownumbers="true" fitStyle="fill" multiselect="true"
              style="margin-left: 5px;margin-right: 5px;">
        <cui:gridCols>
            <cui:gridCol name="id" hidden="true">id</cui:gridCol>
            <cui:gridCol name="manageNumb" width="20">序列号</cui:gridCol>
            <cui:gridCol name="macAddress" width="20">MAC地址</cui:gridCol>

            <cui:gridCol name="ip" width="20">IP</cui:gridCol>
            <cui:gridCol name="deptName" width="15">单位</cui:gridCol>
            <cui:gridCol name="uses" width="50">用途</cui:gridCol>
            <cui:gridCol name="userName" width="15">用户</cui:gridCol>
        </cui:gridCols>
        <cui:gridPager gridId="grid${idSuffix}"/>
    </cui:grid>
</div>

<cui:form id="expForm${idSuffix}" action="${ctx}/driverManage/queryList/exp"
          target="_blank" style="display: none;">
    <input type="hidden" name="manageNumb"/>
    <input type="hidden" name="macAddress"/>
    <input type="hidden" name="ip"/>
    <input type="hidden" name="deptName"/>
    <input type="hidden" name="uses"/>
    <input type="hidden" name="userName"/>
</cui:form>
<cui:dialog id="dialogA${idSuffix}" modal="true" autoOpen="false" reLoadOnOpen="true"
            focusInput="false" resizable="true" autoDestroy="true" maximized="false"></cui:dialog>
<script type="text/javascript">
    var driverManage_list_fun = (function (win, $) {
        function sample() {
            this.postData = {
                descs: 'CREATE_TIME'
            }
        }

        var $grid = $('#grid${idSuffix}');
        var $expForm = $('#expForm${idSuffix}');
        //添加
        sample.prototype.add = function () {
            var url = '${ctx}/driverManage/add';
            $('#dialogA${idSuffix}').dialog('option', {
                url: url,
                title: '硬件录入信息[添加]',
                asyncType: 'get',
                width: 520,
                height: 340,
                buttons: null
            }).dialog('open');
        }
        //删除
        sample.prototype.del = function () {
            var applicationBoxGrid = $("#grid${idSuffix}");
            var sel = applicationBoxGrid.grid("option", "selarrrow");
            if (sel.length == 0) {
                message("请至少选择一条！");
                return;
            }

            var idArr = new Array();
            for (var i = 0; i < sel.length; i++) {
                idArr.push(applicationBoxGrid.grid("getRowData", sel[i]).id);
            }
            remove(idArr.toString());
        }

        //刷新列表
        sample.prototype.reloadGrid = function () {
            $grid.grid('reload');
        }

        sample.prototype.titleFmt = function (cellValue, options, rowObject) {
            var result = '<a style="color:rgb(67,71,201)" onclick="mailReceive_list_sample.edit(\'' + rowObject.id + '\',\'' + rowObject.mailSendId + '\')">' + cellValue + '</a>';
            return result;
        }

        //查看
        sample.prototype.edit = function () {
            var applicationBoxGrid = $("#grid${idSuffix}");
            var sel = applicationBoxGrid.grid("option", "selarrrow");
            if (sel.length > 1) {
                message("只能选择一条！");
                return;
            } else if (sel.length < 1) {
                message("请至少选择一条！");
                return;
            }
            debugger;
            var id = applicationBoxGrid.grid("getRowData", sel[0]).id;


            var url = '${ctx}/driverManage/edit?id=' + id;
            $('#dialogA${idSuffix}').dialog('option', {
                url: url,
                title: '硬件修改信息[修改]',
                asyncType: 'get',
                width: 520,
                height: 340,
                buttons: null
            }).dialog('open');
        }

        sample.prototype.exp = function () {
            $expForm.submit();
        }

        function remove(ids) {
            $.confirm("确认删除？", function (r) {
                    if (r) {
                        loading("删除中...");
                        $.ajax({
                            type: 'post',
                            url: "${ctx}/driverManage/removeDrivers",
                            data: {ids: ids},
                            dataType: 'json',
                            success: function (data) {
                                hide();
                                driverManage_list_sample.reloadGrid();

                            },
                            error: function (r) {
                                error(r);
                                hide();
                            }
                        });
                    }
                }
            );
        }


        return sample;
    })
    (window, $);

    var driverManage_list_sample = new driverManage_list_fun();
    window['driverManage_list_fun'] = null;
    delete window['driverManage_list_fun'];


</script>
