<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
    pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
%>
<div style="height: 100%;">
    <div class="nav2"><img src="${ctx}/static/cm/image/sjj-nav.png"/>文电批阅</div>
    <div class="table-head">
        <div class="table-title">重打印申请</div>

    </div>
    <cui:grid id="grid${idSuffix}" url="${ctx}/re-print-apply/queryRequestViewList" postData="rePrintRequest_index_sample.postData"
              asyncType="get" sortorder="desc" loadonce="false" rownumbers="true" rownumName="序号" fitStyle="fill"
              style="margin-left: 5px;margin-right: 5px;">
        <cui:gridCols>


            <cui:gridCol name="id" hidden="true">id</cui:gridCol>
            <cui:gridCol name="status" hidden="true">status</cui:gridCol>
            <cui:gridCol name="reAttachmentName" formatter="rePrintRequest_index_sample.titleFmt" align="center">文件名</cui:gridCol>
            <cui:gridCol name="rePrintNum" align="center">申请打印份数</cui:gridCol>
            <cui:gridCol name="rePrintReason" align="center">申请原因</cui:gridCol>
            <cui:gridCol name="createTime" align="center">申请时间</cui:gridCol>
            <cui:gridCol name="approvedUserName" align="center">审批人</cui:gridCol>
            <cui:gridCol name="approvedText" align="center">审批内容</cui:gridCol>
            <cui:gridCol name="approvedDate" align="center">审批时间</cui:gridCol>
            <cui:gridCol name="status" align="center" formatter="rePrintRequest_index_sample.statusFmt">当前状态</cui:gridCol>
        </cui:gridCols>
        <cui:gridPager gridId="grid${idSuffix}"/>
    </cui:grid>
    <cui:dialog id="dialog${idSuffix}" modal="true" autoOpen="false" reLoadOnOpen="true"
                focusInput="false" resizable="true" autoDestroy="true" maximized="false"></cui:dialog>
</div>
<script type="text/javascript">
    var rePrintRequest_fun = (function (win, $) {

        function sample() {
            this.postData = {
                descs: 'CREATE_TIME'
            }
        }

        var $grid = $('#grid${idSuffix}');

        //刷新列表
        sample.prototype.reloadGrid = function () {
            $grid.grid('reload');
        }

        sample.prototype.titleFmt = function (cellValue, options, rowObject) {
            var result = '<a onclick="rePrintRequest_index_sample.edit(\'' + rowObject.id + '\',\'' + rowObject.reAttachmentId + '\')">' + cellValue + '</a>';
            return result;
        }

        sample.prototype.statusFmt = function (cellValue, options, rowObject) {
            var result = '';
            var status = rowObject.status;
            if (status == '0') {
                result = '待审批';
            } else if (status == '1') {
                result = '审批通过';
            } else if (status == '-1') {
                result = '审批拒绝';
            } else {
                result = status;
            }
            return result;
        }

        //查看
        sample.prototype.edit = function (id, reAttachmentId) {
            var url = '${ctx}/re-print-apply/answerApply/' + id + '/' + reAttachmentId+'/apply';
            $('#dialog${idSuffix}').dialog('option', {
                url: url,
                title: '重打印申请',
                asyncType: 'get',
                width: 600,
                height: 400,
                buttons: null
            }).dialog('open');
        }
        return sample;
    })(window, $);

    var rePrintRequest_index_sample = new rePrintRequest_fun();
    window['rePrintRequest_fun'] = null;
    delete window['rePrintRequest_fun'];
</script>
