<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
    pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
%>
<div style="height: 100%;">
    <c:if test="${status!='all'}">
    <div class="nav2"><img src="${ctx}/static/cm/image/sjj-nav.png"/>文电批阅</div>
    <div class="table-head">
        <div class="table-title">重打印审批</div>
        </div>
    </c:if>
        <c:if test="${status=='all'}">
            <div class="nav2"><img src="${ctx}/static/cm/image/sjj-nav.png"/>系统管理</div>


            <cui:form id="queryForm${idSuffix}" method="post" style="padding-top: 10px;margin: 0px;height: 90px;">
                <div>
                    &nbsp <label>文件名:</label>
                    <cui:input id="reAttachmentName" name="reAttachmentName" type="text" width="150" placeholder=""
                               pattern="//^([\u4e00-\u9fa5]|[a-zA-Z0-9])+$//" errMsg="请输入合法字符"/>
                    <label>申请时间:</label>
                    <cui:datepicker id="createTimeStart" name="createTimeStart" dateFormat="yyyy-MM-dd HH:mm:ss" readonly="false"
                                    width="150" showOn="button"/>
                    <label>至</label>
                    <cui:datepicker id="createTimeEnd" name="createTimeEnd" dateFormat="yyyy-MM-dd HH:mm:ss" readonly="false"
                                    width="150"
                                    showOn="button"/>
                    &nbsp<label>申请人:</label>
                    <cui:input id="applyUserName" name="applyUserName" type="text" width="150" placeholder=""
                               pattern="//^([\u4e00-\u9fa5]|[a-zA-Z0-9])+$//" errMsg="请输入合法字符"/>
                </div>
                <div style="margin-top: 8px;">
                    &nbsp <label>审批人:</label>
                    <cui:input id="approvedUserName" name="approvedUserName" type="text" width="150" placeholder=""
                               pattern="//^([\u4e00-\u9fa5]|[a-zA-Z0-9])+$//" errMsg="请输入合法字符"/>
                    <label>审批时间:</label>
                    <cui:datepicker id="approvedDateStart" name="approvedDateStart" dateFormat="yyyy-MM-dd HH:mm:ss" readonly="false"
                                    width="150" showOn="button"/>
                    <label>至</label>
                    <cui:datepicker id="approvedDateEnd" name="approvedDateEnd" dateFormat="yyyy-MM-dd HH:mm:ss" readonly="false"
                                    width="150"
                                    showOn="button"/>
                    &nbsp<cui:button id="logSearch" componentCls="sbax_button_blue " width="80"
                                     icons="icon-search" label="查询"
                                     onClick="rePrintResponse_index_sample.searchLog"/>
                    &nbsp<cui:button id="resetSearch" componentCls="sbax_button_yellow" icons="icon-reset" width="80"
                                     label="重置"
                                     onClick="rePrintResponse_index_sample.reset()"/>
                </div>
            </cui:form>
        </c:if>
        <cui:grid id="grid${idSuffix}" url="${ctx}/re-print-apply/queryApplyViewList?status=${status}"
                  postData="rePrintResponse_index_sample.postData"
                  asyncType="get" sortorder="desc" loadonce="false" rownumbers="true" fitStyle="fill" rownumName="序号"
                  style="margin-left: 5px;margin-right: 5px;">
            <cui:gridCols>
                <cui:gridCol name="id" hidden="true">id</cui:gridCol>
                <c:if test="${status=='0'}">
                    <cui:gridCol name="applyUserName">申请人</cui:gridCol>
                    <cui:gridCol name="applyDeptName">申请单位</cui:gridCol>
                    <cui:gridCol name="reAttachmentName" formatter="rePrintResponse_index_sample.titleFmt"
                    >文件名</cui:gridCol>
                    <cui:gridCol name="rePrintReason">申请原因</cui:gridCol>
                    <cui:gridCol name="createTime">申请时间</cui:gridCol>
                    <cui:gridCol name="rePrintNum">申请打印份数</cui:gridCol>
                </c:if>

                <c:if test="${status!='0'}">
                    <cui:gridCol name="applyUserName">申请人</cui:gridCol>
                    <cui:gridCol name="reAttachmentName"
                    >文件名</cui:gridCol>
                    <cui:gridCol name="rePrintNum">打印份数</cui:gridCol>
                    <cui:gridCol name="rePrintReason">申请原因</cui:gridCol>
                    <cui:gridCol name="createTime">申请时间</cui:gridCol>
                    <c:if test="${status=='all'}">
                        <cui:gridCol name="approvedUserName">审批人</cui:gridCol>
                        <cui:gridCol name="approvedDate">审批时间</cui:gridCol>
                    </c:if>
                    <cui:gridCol name="status"
                                 formatter="rePrintResponse_index_sample.statusFmt">当前状态</cui:gridCol>
                </c:if>


            </cui:gridCols>


            <cui:gridPager gridId="grid${idSuffix}"/>
        </cui:grid>
        <cui:dialog id="dialog${idSuffix}" modal="true" autoOpen="false" reLoadOnOpen="true"
                    focusInput="false" resizable="true" autoDestroy="true" maximized="false" ></cui:dialog>
    </div>
    <script type="text/javascript">
        var rePrintResponse_index_fun = (function (win, $) {

            function sample() {
                this.postData = {
                    descs: 'CREATE_TIME'
                }
            }

            var $grid = $('#grid${idSuffix}');

            //刷新列表
            sample.prototype.reloadGrid = function () {
                $grid.grid('reload');
            }

            sample.prototype.titleFmt = function (cellValue, options, rowObject) {
                var result = '<a onclick="rePrintResponse_index_sample.edit(\'' + rowObject.id + '\',\'' + rowObject.reAttachmentId + '\')">' + cellValue + '</a>';
                return result;
            }

            sample.prototype.statusFmt = function (cellValue, options, rowObject) {
                var result = '';
                var status = rowObject.status;
                if (status == '0') {
                    result = '待审批';
                } else if (status == '1') {
                    result = '审批通过';
                } else if (status == '-1') {
                    result = '审批拒绝';
                } else {
                    result = status;
                }
                return result;
            }

            //查看
            sample.prototype.edit = function (id, reAttachmentId) {
                var url = '${ctx}/re-print-apply/answerApply/' + id + '/' + reAttachmentId+'/approve';
                $('#dialog${idSuffix}').dialog('option', {
                    url: url,
                    title: '重打印审批',
                    asyncType: 'get',
                    width: 600,
                    height: 400,
                    buttons: null
                }).dialog('open');
            }

            //重置
            sample.prototype.reset = function () {
                var $form = $('#queryForm${idSuffix}');
                $form.form('clear');
                $form.form('reset');
            }
            //查询
            sample.prototype.searchLog = function () {
                debugger;
                var $form = $('#queryForm${idSuffix}');
                var params = $form.form('formData');
                var $grid = $('#grid${idSuffix}');
                this.postData = params;
                $grid.grid('option', 'postData', params);
                $grid.grid('reload', '${ctx}/re-print-apply/queryByKeyWords');
            }

            return sample;
        })(window, $);

        var rePrintResponse_index_sample = new rePrintResponse_index_fun();
        window['rePrintResponse_index_fun'] = null;
        delete window['rePrintResponse_index_fun'];
    </script>
