<%@ page language="java" contentType="text/html;charset=UTF-8" pageEncoding="UTF-8" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="shiro" uri="http://shiro.apache.org/tags" %>
<%@ taglib prefix="cui" tagdir="/WEB-INF/tags" %>
<c:set var="ctx" value="${pageContext.request.contextPath}"/>
<%
    pageContext.setAttribute("idSuffix", String.valueOf(System.currentTimeMillis()).substring(6));
%>
<style>

</style>
<div class="table-head">
    <div class="table-title">自定义组</div>
    <div class="table-head-right">
        <a onclick="selfDefindeGroup_list_sample.add()">添加</a>
        <a onclick="selfDefindeGroup_list_sample.del()">删除</a>
    </div>
</div>
<cui:grid id="logsGrid${idSuffix}" url="${ctx}/selfDefindeGroup/search" asyncType="get"
          sortorder="desc" loadonce="false" rownumbers="true" fitStyle="fill" multiselect="true" altRows="true"
          style="margin-left: 5px;margin-right: 5px;">

    <cui:gridCols>
        <cui:gridCol name="id" hidden="true">id</cui:gridCol>
        <cui:gridCol name="groupName" formatter="selfDefindeGroup_list_sample.titleFmt" align="center">自定义组名称</cui:gridCol>
        <cui:gridCol name="describtion" align="center">描述</cui:gridCol>
    </cui:gridCols>
    <cui:gridPager gridId="logsGrid${idSuffix}"/>
</cui:grid>
</div>
<cui:dialog id="dialogA${idSuffix}" modal="true" autoOpen="false" reLoadOnOpen="true"
            focusInput="false" resizable="true" autoDestroy="true" maximized="false"></cui:dialog>
<script type="text/javascript">
    var selfDefindeGroup_list_fun = (function (win, $) {
        function sample() {
            this.postData = {
                descs: 'SEND_TIME'
            }
        }
        var $grid = $('#logsGrid${idSuffix}');
        //添加
        sample.prototype.add = function () {
            var url = '${ctx}/selfDefindeGroup/addOrUpdate';
            $('#dialogA${idSuffix}').dialog('option', {
                url: url,
                title: '添加自定义组',
                asyncType: 'get',
                width: 705,
                height: 580,
                buttons: null
            }).dialog('open');
        }

        //修改
        sample.prototype.edit = function (id) {
            var url = '${ctx}/selfDefindeGroup/addOrUpdate?id='+id;
            $('#dialogA${idSuffix}').dialog('option', {
                url: url,
                title: '修改自定义组',
                asyncType: 'get',
                width: 690,
                height: 554,
                buttons: null
            }).dialog('open');
        }

        sample.prototype.titleFmt = function (cellValue, options, rowObject) {
            var result = '<a onclick="selfDefindeGroup_list_sample.edit(\'' + rowObject.id + '\')">' + cellValue + '</a>';
            return result;
        }

        //删除
        sample.prototype.del = function () {
            var applicationBoxGrid = $("#logsGrid${idSuffix}");
            var sel = applicationBoxGrid.grid("option", "selarrrow");
            if (sel.length == 0) {
                message("至少选择一条记录！");
                return;
            }
            var idArr = new Array();
            for (var i = 0; i < sel.length; i++) {
                idArr.push(applicationBoxGrid.grid("getRowData", sel[i]).id);
            }
            remove(idArr.toString());

        }

        //刷新列表
        sample.prototype.reloadGrid = function () {
            $grid.grid('reload');
        }
        function remove(ids) {
            var applicationBoxGrid = $("#logsGrid${idSuffix}");

            $.confirm("确认删除该组？", function (r) {
                    if (r) {
                        loading("删除中...");
                        $.ajax({
                            type: 'post',
                            url: "${ctx}/selfDefindeGroup/removeGroup",
                            data: {ids: ids},
                            dataType: 'json',
                            success: function (data) {
                                if (data == true) {
                                    message("删除成功！");

                                    hide();
                                    applicationBoxGrid.grid("reload");
                                } else {
                                    message(data.exception.message);
                                    hide();
                                    applicationBoxGrid.grid("reload");
                                }

                            },
                            error: function (r) {
                                error(r);
                                hide();
                                applicationBoxGrid.grid("reload");
                            }
                        });
                    }
                }
            );
        }


        return sample;
    })(window, $);

    var selfDefindeGroup_list_sample = new selfDefindeGroup_list_fun();
    window['selfDefindeGroup_list_fun'] = null;
    delete window['selfDefindeGroup_list_fun'];
</script>

