
CREATE TABLE "CM_SFW2"."ATTACHMENT"
(
"ID" VARCHAR(50) NOT NULL,
"CREATOR_ID" VARCHAR(50),
"CREATOR_NAME" VARCHAR(200),
"CREATE_TIME" DATETIME(6),
"MODULE" VARCHAR(50),
"RELEVANCE_ID" VARCHAR(50),
"DISK_FILE_ID" VARCHAR(50),
"CREATE_DEPT_ID" VARCHAR(50),
"CREATE_DEPT_NAME" VARCHAR(200),
CONSTRAINT "PK_ATTACHMENT" NOT CLUSTER PRIMARY KEY("ID")) STORAGE(ON "MAIN", CLUSTERBTR) ;

COMMENT ON TABLE "CM_SFW2"."ATTACHMENT" IS '附件';
COMMENT ON COLUMN "CM_SFW2"."ATTACHMENT"."CREATE_DEPT_ID" IS '创建人部门id';
COMMENT ON COLUMN "CM_SFW2"."ATTACHMENT"."CREATE_DEPT_NAME" IS '创建人部门名称';
COMMENT ON COLUMN "CM_SFW2"."ATTACHMENT"."CREATE_TIME" IS '创建时间';
COMMENT ON COLUMN "CM_SFW2"."ATTACHMENT"."CREATOR_ID" IS '创建人id';
COMMENT ON COLUMN "CM_SFW2"."ATTACHMENT"."CREATOR_NAME" IS '创建人名称';
COMMENT ON COLUMN "CM_SFW2"."ATTACHMENT"."DISK_FILE_ID" IS '文件表id';
COMMENT ON COLUMN "CM_SFW2"."ATTACHMENT"."MODULE" IS '所属模块';
COMMENT ON COLUMN "CM_SFW2"."ATTACHMENT"."RELEVANCE_ID" IS '关联id';


CREATE TABLE "CM_SFW2"."ATTACHMENT_PRINT_NUM"
(
"ID" VARCHAR(50) NOT NULL,
"MIAL_RECEIVE_ID" VARCHAR(50),
"PRINT_NUMB" VARCHAR(50),
"ATTACH_ID" VARCHAR(50),
CLUSTER PRIMARY KEY("ID")) STORAGE(ON "MAIN", CLUSTERBTR) ;

COMMENT ON TABLE "CM_SFW2"."ATTACHMENT_PRINT_NUM" IS '附件打印次数表';
COMMENT ON COLUMN "CM_SFW2"."ATTACHMENT_PRINT_NUM"."ATTACH_ID" IS '附件ID';
COMMENT ON COLUMN "CM_SFW2"."ATTACHMENT_PRINT_NUM"."ID" IS '主键ID';
COMMENT ON COLUMN "CM_SFW2"."ATTACHMENT_PRINT_NUM"."MIAL_RECEIVE_ID" IS '附件对应收件ID';
COMMENT ON COLUMN "CM_SFW2"."ATTACHMENT_PRINT_NUM"."PRINT_NUMB" IS '可打印次数';


CREATE TABLE "CM_SFW2"."DISK_FILE"
(
"ID" VARCHAR(50) NOT NULL,
"CREATOR_ID" VARCHAR(50),
"CREATOR_NAME" VARCHAR(200),
"CREATE_TIME" DATETIME(6),
"ORIGINAL_NAME" VARCHAR(300),
"FILE_NAME" VARCHAR(200),
"CONTENT_TYPE" VARCHAR(200),
"EXT" VARCHAR(50),
"FILE_SIZE" NUMBER,
"PATH" VARCHAR(600),
"TEXT" CLOB,
CONSTRAINT "PK_DISK_FILE" NOT CLUSTER PRIMARY KEY("ID")) STORAGE(ON "MAIN", CLUSTERBTR) ;

COMMENT ON TABLE "CM_SFW2"."DISK_FILE" IS '附件文件';
COMMENT ON COLUMN "CM_SFW2"."DISK_FILE"."CONTENT_TYPE" IS '文件类型';
COMMENT ON COLUMN "CM_SFW2"."DISK_FILE"."CREATE_TIME" IS '创建时间';
COMMENT ON COLUMN "CM_SFW2"."DISK_FILE"."CREATOR_ID" IS '创建人id';
COMMENT ON COLUMN "CM_SFW2"."DISK_FILE"."CREATOR_NAME" IS '创建人名称';
COMMENT ON COLUMN "CM_SFW2"."DISK_FILE"."EXT" IS '文件扩展名';
COMMENT ON COLUMN "CM_SFW2"."DISK_FILE"."FILE_NAME" IS '现文件名';
COMMENT ON COLUMN "CM_SFW2"."DISK_FILE"."FILE_SIZE" IS '文件大小(byte)';
COMMENT ON COLUMN "CM_SFW2"."DISK_FILE"."ORIGINAL_NAME" IS '原文件名';
COMMENT ON COLUMN "CM_SFW2"."DISK_FILE"."PATH" IS '相对路径';
COMMENT ON COLUMN "CM_SFW2"."DISK_FILE"."TEXT" IS '附件文本内容';


CREATE TABLE "CM_SFW2"."DRIVERS_MANAGE"
(
"ID" VARCHAR(100) NOT NULL,
"MANAGE_NUMB" VARCHAR(200),
"MAC_ADDRESS" VARCHAR(200),
"IP" VARCHAR(200),
"DEPT_ID" VARCHAR(50),
"DEPT_NAME" VARCHAR(200),
"USES" VARCHAR(500),
"USER_ID" VARCHAR(50),
"USER_NAME" VARCHAR(200),
"CREATE_TIME" DATETIME(6),
CLUSTER PRIMARY KEY("ID")) STORAGE(ON "MAIN", CLUSTERBTR) ;

COMMENT ON TABLE "CM_SFW2"."DRIVERS_MANAGE" IS '硬件设备录入';
COMMENT ON COLUMN "CM_SFW2"."DRIVERS_MANAGE"."CREATE_TIME" IS '创建时间';
COMMENT ON COLUMN "CM_SFW2"."DRIVERS_MANAGE"."DEPT_ID" IS '单位ID';
COMMENT ON COLUMN "CM_SFW2"."DRIVERS_MANAGE"."DEPT_NAME" IS '单位名字';
COMMENT ON COLUMN "CM_SFW2"."DRIVERS_MANAGE"."ID" IS '主键ID';
COMMENT ON COLUMN "CM_SFW2"."DRIVERS_MANAGE"."IP" IS 'IP';
COMMENT ON COLUMN "CM_SFW2"."DRIVERS_MANAGE"."MAC_ADDRESS" IS 'MAC_地址';
COMMENT ON COLUMN "CM_SFW2"."DRIVERS_MANAGE"."MANAGE_NUMB" IS '序号';
COMMENT ON COLUMN "CM_SFW2"."DRIVERS_MANAGE"."USER_ID" IS '用户ID';
COMMENT ON COLUMN "CM_SFW2"."DRIVERS_MANAGE"."USER_NAME" IS '用户名字';
COMMENT ON COLUMN "CM_SFW2"."DRIVERS_MANAGE"."USES" IS '用途';


CREATE TABLE "CM_SFW2"."EXPIRE_APPLY"
(
"ID" VARCHAR(50) NOT NULL,
"EXPIRE_DATE" DATE,
"APPLY_REASON" VARCHAR(2000),
"APPLY_DATE" DATETIME(6),
"APPLY_USER_ID" VARCHAR(50),
"APPLY_USER_NAME" VARCHAR(200),
"APPROVE_USER_ID" VARCHAR(50),
"APPROVE_USER_NAME" VARCHAR(200),
"APPROVE_RESULT" INTEGER,
"APPROVE_DETAIL" VARCHAR(2000),
"APPROVE_DATE" DATETIME(6),
"MAIL_RECEIVE_ID" VARCHAR(50),
"APPLY_DEPT_ID" VARCHAR(50),
"APPLY_DEPT_NAME" VARCHAR(200),
"APPROVE_DEPT_ID" VARCHAR(50),
"APPROVE_DEPT_NAME" VARCHAR(200),
CLUSTER PRIMARY KEY("ID")) STORAGE(ON "MAIN", CLUSTERBTR) ;

COMMENT ON TABLE "CM_SFW2"."EXPIRE_APPLY" IS '延期申请';
COMMENT ON COLUMN "CM_SFW2"."EXPIRE_APPLY"."APPLY_DATE" IS '申请时间';
COMMENT ON COLUMN "CM_SFW2"."EXPIRE_APPLY"."APPLY_DEPT_ID" IS '申请部门id';
COMMENT ON COLUMN "CM_SFW2"."EXPIRE_APPLY"."APPLY_DEPT_NAME" IS '申请部门名称';
COMMENT ON COLUMN "CM_SFW2"."EXPIRE_APPLY"."APPLY_REASON" IS '申请原因';
COMMENT ON COLUMN "CM_SFW2"."EXPIRE_APPLY"."APPLY_USER_ID" IS '申请人id';
COMMENT ON COLUMN "CM_SFW2"."EXPIRE_APPLY"."APPLY_USER_NAME" IS '申请人名称';
COMMENT ON COLUMN "CM_SFW2"."EXPIRE_APPLY"."APPROVE_DATE" IS '审批时间';
COMMENT ON COLUMN "CM_SFW2"."EXPIRE_APPLY"."APPROVE_DEPT_ID" IS '审批部门id';
COMMENT ON COLUMN "CM_SFW2"."EXPIRE_APPLY"."APPROVE_DEPT_NAME" IS '审批部门名称';
COMMENT ON COLUMN "CM_SFW2"."EXPIRE_APPLY"."APPROVE_DETAIL" IS '审批信息';
COMMENT ON COLUMN "CM_SFW2"."EXPIRE_APPLY"."APPROVE_RESULT" IS '审批结果（0：未审批，1：通过，2：不通过）';
COMMENT ON COLUMN "CM_SFW2"."EXPIRE_APPLY"."APPROVE_USER_ID" IS '审批人id';
COMMENT ON COLUMN "CM_SFW2"."EXPIRE_APPLY"."APPROVE_USER_NAME" IS '审批人名称';
COMMENT ON COLUMN "CM_SFW2"."EXPIRE_APPLY"."EXPIRE_DATE" IS '延期日期';
COMMENT ON COLUMN "CM_SFW2"."EXPIRE_APPLY"."MAIL_RECEIVE_ID" IS '收文id';


CREATE TABLE "CM_SFW2"."LOGIN_LOG"
(
"ID" VARCHAR(50),
"USER_ID" VARCHAR(50),
"USER_NAME" VARCHAR(200),
"DEPT_ID" VARCHAR(50),
"DEPT_NAME" VARCHAR(200),
"IP" VARCHAR(200),
"LOGIN_TIME" DATETIME(6),
"LOGIN_STATUS" VARCHAR(5),
"LOG_DETAIL" VARCHAR(1000)) STORAGE(ON "MAIN", CLUSTERBTR) ;

COMMENT ON TABLE "CM_SFW2"."LOGIN_LOG" IS '登录日志';
COMMENT ON COLUMN "CM_SFW2"."LOGIN_LOG"."DEPT_ID" IS '登录部门id';
COMMENT ON COLUMN "CM_SFW2"."LOGIN_LOG"."DEPT_NAME" IS '登录部门名称';
COMMENT ON COLUMN "CM_SFW2"."LOGIN_LOG"."IP" IS 'IP';
COMMENT ON COLUMN "CM_SFW2"."LOGIN_LOG"."LOGIN_STATUS" IS '状态（0：失败，1：成功）';
COMMENT ON COLUMN "CM_SFW2"."LOGIN_LOG"."LOGIN_TIME" IS '登录时间';
COMMENT ON COLUMN "CM_SFW2"."LOGIN_LOG"."LOG_DETAIL" IS '详细';
COMMENT ON COLUMN "CM_SFW2"."LOGIN_LOG"."USER_ID" IS '登录人id';
COMMENT ON COLUMN "CM_SFW2"."LOGIN_LOG"."USER_NAME" IS '登录人名称';


CREATE TABLE "CM_SFW2"."LOGS"
(
"ID" VARCHAR(50) NOT NULL,
"LOG_TYPE" VARCHAR(20),
"USER_ID" VARCHAR(50),
"USER_NAME" VARCHAR(200),
"OPERATE" VARCHAR(3000),
"STATUS" VARCHAR(50),
"CREATE_TIME" DATETIME(6),
"URL" VARCHAR(300),
"IP" VARCHAR(200),
"ORG_ID" VARCHAR(50),
"ERROR_MSG" VARCHAR(2000),
"ORG_NAME" VARCHAR(200),
"MODULE" VARCHAR(200),
"OPERATE_OBJECT" VARCHAR(1000),
"OPERATE_OBJECT_TYPE" VARCHAR(50),
NOT CLUSTER PRIMARY KEY("ID")) STORAGE(ON "MAIN", CLUSTERBTR) ;

COMMENT ON COLUMN "CM_SFW2"."LOGS"."CREATE_TIME" IS '创建时间';
COMMENT ON COLUMN "CM_SFW2"."LOGS"."ERROR_MSG" IS '错误信息';
COMMENT ON COLUMN "CM_SFW2"."LOGS"."ID" IS '主键ID';
COMMENT ON COLUMN "CM_SFW2"."LOGS"."IP" IS '操作客户端ip';
COMMENT ON COLUMN "CM_SFW2"."LOGS"."LOG_TYPE" IS '操作类型';
COMMENT ON COLUMN "CM_SFW2"."LOGS"."MODULE" IS '操作模块';
COMMENT ON COLUMN "CM_SFW2"."LOGS"."OPERATE" IS '操作详情';
COMMENT ON COLUMN "CM_SFW2"."LOGS"."OPERATE_OBJECT" IS '操作对象';
COMMENT ON COLUMN "CM_SFW2"."LOGS"."OPERATE_OBJECT_TYPE" IS '操作对象类型';
COMMENT ON COLUMN "CM_SFW2"."LOGS"."ORG_ID" IS '操作部门ID';
COMMENT ON COLUMN "CM_SFW2"."LOGS"."ORG_NAME" IS '操作部门名字';
COMMENT ON COLUMN "CM_SFW2"."LOGS"."STATUS" IS '操作状态';
COMMENT ON COLUMN "CM_SFW2"."LOGS"."URL" IS '路径';
COMMENT ON COLUMN "CM_SFW2"."LOGS"."USER_ID" IS '操作人ID';
COMMENT ON COLUMN "CM_SFW2"."LOGS"."USER_NAME" IS '操作人名字';


CREATE TABLE "CM_SFW2"."MAIL_RECEIVE"
(
"ID" VARCHAR(50) NOT NULL,
"MAIL_SEND_ID" VARCHAR(50),
"DEPT_ID" VARCHAR(50),
"DEPT_NAME" VARCHAR(200),
"STATUS" VARCHAR(5),
"RECEIVE_DATE" DATETIME(6),
"REPLY_TEXT" VARCHAR(800),
"RECEIVE_USER_ID" VARCHAR(50),
"RECEIVE_USER_NAME" VARCHAR(200),
"EXTEND_TIME" VARCHAR(5),
"REMARK" VARCHAR(800),
CLUSTER PRIMARY KEY("ID")) STORAGE(ON "MAIN", CLUSTERBTR) ;

COMMENT ON TABLE "CM_SFW2"."MAIL_RECEIVE" IS '收件信息';
COMMENT ON COLUMN "CM_SFW2"."MAIL_RECEIVE"."DEPT_ID" IS '收件单位id';
COMMENT ON COLUMN "CM_SFW2"."MAIL_RECEIVE"."DEPT_NAME" IS '收件单位';
COMMENT ON COLUMN "CM_SFW2"."MAIL_RECEIVE"."EXTEND_TIME" IS '是否延期';
COMMENT ON COLUMN "CM_SFW2"."MAIL_RECEIVE"."ID" IS 'id';
COMMENT ON COLUMN "CM_SFW2"."MAIL_RECEIVE"."MAIL_SEND_ID" IS 'MAIL_SEND的id';
COMMENT ON COLUMN "CM_SFW2"."MAIL_RECEIVE"."RECEIVE_DATE" IS '签收时间';
COMMENT ON COLUMN "CM_SFW2"."MAIL_RECEIVE"."RECEIVE_USER_ID" IS '签收人id';
COMMENT ON COLUMN "CM_SFW2"."MAIL_RECEIVE"."RECEIVE_USER_NAME" IS '签收人';
COMMENT ON COLUMN "CM_SFW2"."MAIL_RECEIVE"."REMARK" IS '备注';
COMMENT ON COLUMN "CM_SFW2"."MAIL_RECEIVE"."REPLY_TEXT" IS '签收回执';
COMMENT ON COLUMN "CM_SFW2"."MAIL_RECEIVE"."STATUS" IS '签收状态（1：未签收，2：已签收）';


CREATE TABLE "CM_SFW2"."MAIL_SEND"
(
"ID" VARCHAR(50) NOT NULL,
"MAIL_TITLE" VARCHAR(500),
"MAIL_TEXT" VARCHAR(2000),
"USER_ID" VARCHAR(50),
"USER_NAME" VARCHAR(200),
"DEPT_ID" VARCHAR(50),
"DEPT_NAME" VARCHAR(200),
"SEND_TIME" DATETIME(6),
"MAIL_TYPE" VARCHAR(50),
"SAFE_LEVEL" VARCHAR(30),
"EMERGENCY" VARCHAR(30),
"PARTY_TIME" DATETIME(6),
"MAIL_PAGE" INTEGER,
"MAIL_NO" VARCHAR(100),
"EFF_DATE" DATE,
"PRINT_NUM" INTEGER,
"CAN_DOWNLOAD" VARCHAR(5),
"NEED_MSG" VARCHAR(5),
"MSG_CONTENT" VARCHAR(800),
"REMARK" VARCHAR(1000),
"PREVIOUS_ID" VARCHAR(50),
"STATUS" VARCHAR(5),
CLUSTER PRIMARY KEY("ID")) STORAGE(ON "MAIN", CLUSTERBTR) ;

COMMENT ON TABLE "CM_SFW2"."MAIL_SEND" IS '发件信息';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."CAN_DOWNLOAD" IS '是否提供下载（0：否，1：是）';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."DEPT_ID" IS '发送部门id';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."DEPT_NAME" IS '发送部门';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."EFF_DATE" IS '有效时间';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."EMERGENCY" IS '紧急程度';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."ID" IS 'id';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."MAIL_NO" IS '发文号';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."MAIL_PAGE" IS '文电页数';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."MAIL_TEXT" IS '正文';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."MAIL_TITLE" IS '标题';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."MAIL_TYPE" IS '文电类型';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."MSG_CONTENT" IS '短信内容';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."NEED_MSG" IS '是否重发短信（0：否）';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."PARTY_TIME" IS '会议时间';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."PREVIOUS_ID" IS '记录原发文id（再次发送时）';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."PRINT_NUM" IS '打印份数';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."REMARK" IS '备注';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."SAFE_LEVEL" IS '密级';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."SEND_TIME" IS '发送时间';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."STATUS" IS '签收状态（0: 未完成,1: 完成）';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."USER_ID" IS '发送人id';
COMMENT ON COLUMN "CM_SFW2"."MAIL_SEND"."USER_NAME" IS '发送人';


CREATE TABLE "CM_SFW2"."NEW_MESSAGES"
(
"ID" VARCHAR(50) NOT NULL,
"FILE_ID" VARCHAR(50),
"MSG_TYPE" VARCHAR(100),
"MSG_DETAIL" VARCHAR(50),
"STATUS" VARCHAR(50),
"MSG_NOTICE_DEPT_ID" VARCHAR(50),
"USER_ID" VARCHAR(50),
CLUSTER PRIMARY KEY("ID")) STORAGE(ON "MAIN", CLUSTERBTR) ;

COMMENT ON TABLE "CM_SFW2"."NEW_MESSAGES" IS '消息';
COMMENT ON COLUMN "CM_SFW2"."NEW_MESSAGES"."FILE_ID" IS '对应文件ID';
COMMENT ON COLUMN "CM_SFW2"."NEW_MESSAGES"."ID" IS '主键ID';
COMMENT ON COLUMN "CM_SFW2"."NEW_MESSAGES"."MSG_DETAIL" IS '消息明细';
COMMENT ON COLUMN "CM_SFW2"."NEW_MESSAGES"."MSG_NOTICE_DEPT_ID" IS '消息通知单位ID';
COMMENT ON COLUMN "CM_SFW2"."NEW_MESSAGES"."MSG_TYPE" IS '消息类型';
COMMENT ON COLUMN "CM_SFW2"."NEW_MESSAGES"."STATUS" IS '阅读状态(0:未读,1:已读)';
COMMENT ON COLUMN "CM_SFW2"."NEW_MESSAGES"."USER_ID" IS '通知用户ID';


CREATE TABLE "CM_SFW2"."PRINT_RECORD"
(
"ID" VARCHAR(50) NOT NULL,
"USER_ID" VARCHAR(50),
"USER_NAME" VARCHAR(200),
"DEPT_ID" VARCHAR(50),
"DEPT_NAME" VARCHAR(200),
"PRINT_TIME" DATETIME(6),
"ATTACHMENT_ID" VARCHAR(50),
"MAIL_RECEIVE_ID" VARCHAR(50),
NOT CLUSTER PRIMARY KEY("ID")) STORAGE(ON "MAIN", CLUSTERBTR) ;

COMMENT ON TABLE "CM_SFW2"."PRINT_RECORD" IS '打印记录';
COMMENT ON COLUMN "CM_SFW2"."PRINT_RECORD"."ATTACHMENT_ID" IS '附件id';
COMMENT ON COLUMN "CM_SFW2"."PRINT_RECORD"."DEPT_ID" IS '打印部门id';
COMMENT ON COLUMN "CM_SFW2"."PRINT_RECORD"."DEPT_NAME" IS '打印部门名称';
COMMENT ON COLUMN "CM_SFW2"."PRINT_RECORD"."MAIL_RECEIVE_ID" IS '收文id';
COMMENT ON COLUMN "CM_SFW2"."PRINT_RECORD"."PRINT_TIME" IS '打印时间';
COMMENT ON COLUMN "CM_SFW2"."PRINT_RECORD"."USER_ID" IS '打印人id';
COMMENT ON COLUMN "CM_SFW2"."PRINT_RECORD"."USER_NAME" IS '打印人名称';


CREATE TABLE "CM_SFW2"."RE_PRINT_APPLY"
(
"ID" VARCHAR(50) NOT NULL,
"APPLY_USER_ID" VARCHAR(50),
"APPLY_USER_NAME" VARCHAR(200),
"APPLY_DEPT_ID" VARCHAR(50),
"APPLY_DEPT_NAME" VARCHAR(200),
"RE_ATTACHMENT_ID" VARCHAR(50),
"RE_ATTACHMENT_NAME" VARCHAR(3000),
"RE_PRINT_NUM" VARCHAR(50),
"RE_PRINT_REASON" VARCHAR(2000),
"CREATE_TIME" DATETIME(6),
"STATUS" VARCHAR(50),
"APPROVED_USER_ID" VARCHAR(50),
"APPROVED_USER_NAME" VARCHAR(200),
"APPROVED_DATE" DATETIME(6),
"APPROVED_TEXT" VARCHAR(2000),
"SEND_ATTACHMENT_DEPT_ID" VARCHAR(50),
"SEND_ATTACHMENT_DEPT_NAME" VARCHAR(200),
"MAIL_RECEIVE_ID" VARCHAR(50),
CLUSTER PRIMARY KEY("ID")) STORAGE(ON "MAIN", CLUSTERBTR) ;

COMMENT ON TABLE "CM_SFW2"."RE_PRINT_APPLY" IS '重打印申请表';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."APPLY_DEPT_ID" IS '申请部门ID';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."APPLY_DEPT_NAME" IS '申请部门名字';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."APPLY_USER_ID" IS '申请人ID';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."APPLY_USER_NAME" IS '申请人姓名';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."APPROVED_DATE" IS '审批时间';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."APPROVED_TEXT" IS '审批内容';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."APPROVED_USER_ID" IS '审批人ID';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."APPROVED_USER_NAME" IS '审批人名字';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."CREATE_TIME" IS '创建时间';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."ID" IS '主键ID';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."MAIL_RECEIVE_ID" IS '对应收件ID';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."RE_ATTACHMENT_ID" IS '申请附件ID';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."RE_ATTACHMENT_NAME" IS '申请附件名';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."RE_PRINT_NUM" IS '重打印分数';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."RE_PRINT_REASON" IS '重打印原因';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."SEND_ATTACHMENT_DEPT_ID" IS '发送附件的部门ID';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."SEND_ATTACHMENT_DEPT_NAME" IS '发送附件的部门名';
COMMENT ON COLUMN "CM_SFW2"."RE_PRINT_APPLY"."STATUS" IS '审批状态(0:待审批,1:审批通过,-1:审批没通过)';


CREATE TABLE "CM_SFW2"."SELF_DEFINED_GROUP"
(
"ID" VARCHAR(50) NOT NULL,
"GROUP_NAME" VARCHAR(200),
"DESCRIBTION" VARCHAR(800),
"CREATE_USER_ID" VARCHAR(50),
"CREATE_USER_NAME" VARCHAR(200),
CLUSTER PRIMARY KEY("ID")) STORAGE(ON "MAIN", CLUSTERBTR) ;

COMMENT ON TABLE "CM_SFW2"."SELF_DEFINED_GROUP" IS '自定义组';
COMMENT ON COLUMN "CM_SFW2"."SELF_DEFINED_GROUP"."CREATE_USER_ID" IS '创建人ID';
COMMENT ON COLUMN "CM_SFW2"."SELF_DEFINED_GROUP"."CREATE_USER_NAME" IS '创建人姓名';
COMMENT ON COLUMN "CM_SFW2"."SELF_DEFINED_GROUP"."DESCRIBTION" IS '描述';
COMMENT ON COLUMN "CM_SFW2"."SELF_DEFINED_GROUP"."GROUP_NAME" IS '组名';
COMMENT ON COLUMN "CM_SFW2"."SELF_DEFINED_GROUP"."ID" IS '主键ID';


CREATE TABLE "CM_SFW2"."SELF_DEFINED_GROUP_USER"
(
"ID" VARCHAR(50) NOT NULL,
"GROUP_ID" VARCHAR(50),
"DEPT_ID" VARCHAR(50),
"DEPT_NAME" VARCHAR(200)) STORAGE(ON "MAIN", CLUSTERBTR) ;

COMMENT ON TABLE "CM_SFW2"."SELF_DEFINED_GROUP_USER" IS '自定义组成员';
COMMENT ON COLUMN "CM_SFW2"."SELF_DEFINED_GROUP_USER"."DEPT_ID" IS '部门ID';
COMMENT ON COLUMN "CM_SFW2"."SELF_DEFINED_GROUP_USER"."DEPT_NAME" IS '部门名字';
COMMENT ON COLUMN "CM_SFW2"."SELF_DEFINED_GROUP_USER"."GROUP_ID" IS '所在组ID';
COMMENT ON COLUMN "CM_SFW2"."SELF_DEFINED_GROUP_USER"."ID" IS '主键ID';


